      double precision function biuni(gg1,gg2,gg3,gg4,gg5,
     ^     ff1,ff2,ff3,ff4,ff5,ff6,ff7,ff8,ff9,cha,row,col,pol)
c...  
c...  H \to Z1 Z1 in a MCHM
c     authors: G. M. Pruna, D. Barducci
c...  
c     
      implicit none 
c     
c#include "looptools.h"
c
      double precision Sqrt2,PI,Nc
      double precision GGG(6),FFF(9),
     ^     gg1,gg2,gg3,gg4,gg5,
     ^     ff1,ff2,ff3,ff4,ff5,ff6,ff7,ff8,ff9,f,g,g0,g0y,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,cha,row,col,pol
      double precision BRN(6,6), BRC(4,4), BRL1(9,9), BRR1(9,9),
     ^     BRL2(9,9), BRR2(9,9), MZ(6), MZ6, MW(4),Mb(9),Mt(9),
     ^     RN(6,6), RC(4,4), RL1(9,9), RR1(9,9),
     ^     RL2(9,9), RR2(9,9), checkMb(9), checkMt(9),
     ^     BRL4(2,2), BRR4(2,2),RL4(2,2),RR4(2,2),
     ^     BRL5(2,2), BRR5(2,2),RL5(2,2),RR5(2,2),
     ^     Mbm(2),Mtn(2),checkMbm(2), checkMtn(2)
      integer i,j,k, nr,icha,irow,icol,ipol
      double precision BMb(9,9),BMt(9,9),AMb(9,9),AMt(9,9),
     ^     PMb(9,9),PMt(9,9),BMm(2,2),BMn(2,2),AMm(2,2),AMn(2,2),
     ^     PMm(2,2),PMn(2,2)
c           
      do i=1,9
         do j=1,9
            BMb(i,j)=0.d0
            BMt(i,j)=0.d0
            AMb(i,j)=0.d0
            AMt(i,j)=0.d0
            PMb(i,j)=0.d0
            PMt(i,j)=0.d0
         enddo
      enddo
      do i=1,2
         do j=1,2
            BMm(i,j)=0.d0
            BMn(i,j)=0.d0
            AMm(i,j)=0.d0
            AMn(i,j)=0.d0
            PMm(i,j)=0.d0
            PMn(i,j)=0.d0
         enddo
      enddo
c
      nr=0
      Sqrt2=dsqrt(2.d0)
c
      f=gg4
      g=gg2
      g0=gg1
      g0y=gg3
      h=gg5
      GG=1.117d0
c     
      mm=ff1
      DBL=ff2
      DBR=ff3
      DTL=ff4
      DTR=ff5
      YB=ff6
      YT=ff7
      MYB=ff8
      MYT=ff9
c     
      GGG(1)=f
      GGG(2)=g
      GGG(3)=g0
      GGG(4)=g0y
      GGG(5)=h
      GGG(6)=GG
c     
      FFF(1)=mm
      FFF(2)=DBL
      FFF(3)=DBR
      FFF(4)=DTL
      FFF(5)=DTR
      FFF(6)=YB
      FFF(7)=YT
      FFF(8)=MYB
      FFF(9)=MYT
c     
      call elements9(BRN,BRC,BRL1,BRR1,BRL2,BRR2,
     ^     BRL4,BRR4,BRL5,BRR5,GGG,FFF)	 
      call BM9(BMb,BMt,BMm,BMn,GGG,FFF)
c
      call jacobi9(BRL1,9,9,Mb,RL1,nr)
      call eigsrt9(Mb,RL1,9,9)
      call transpose9(RL1,9)
      do i=1,9
         Mb(i)=dsqrt(dabs(Mb(i)))
      enddo
c     
      call jacobi9(BRR1,9,9,checkMb,RR1,nr)
      call eigsrt9(checkMb,RR1,9,9)
      call transpose9(RR1,9)
c     
      call jacobi9(BRL2,9,9,Mt,RL2,nr)
      call eigsrt9(Mt,RL2,9,9)
      call transpose9(RL2,9)
      do i=1,9
         Mt(i)=dsqrt(dabs(Mt(i)))
      enddo
c     
      call jacobi9(BRR2,9,9,checkMt,RR2,nr)
      call eigsrt9(checkMt,RR2,9,9)
      call transpose9(RR2,9)
c
      call jacobi9(BRL4,2,2,Mbm,RL4,nr)
      call eigsrt9(Mbm,RL4,2,2)
      call transpose9(RL4,2)
      do i=1,2
         Mbm(i)=dsqrt(dabs(Mbm(i)))
      enddo
c     
      call jacobi9(BRR4,2,2,checkMbm,RR4,nr)
      call eigsrt9(checkMbm,RR4,2,2)
      call transpose9(RR4,2)
c
      call jacobi9(BRL5,2,2,Mtn,RL5,nr)
      call eigsrt9(Mtn,RL5,2,2)
      call transpose9(RL5,2)
      do i=1,2
         Mtn(i)=dsqrt(dabs(Mtn(i)))
      enddo
c     
      call jacobi9(BRR5,2,2,checkMtn,RR5,nr)
      call eigsrt9(checkMtn,RR5,2,2)
      call transpose9(RR5,2)
c
c     Adjusting the signs
c     
      call transpose9(RR1,9)
      call matxmat9(BMb,RR1,9,9,9,9,PMb)
      call transpose9(RR1,9)
      call matxmat9(RL1,PMb,9,9,9,9,AMb)
c     
      call transpose9(RR2,9)
      call matxmat9(BMt,RR2,9,9,9,9,PMt)
      call transpose9(RR2,9)
      call matxmat9(RL2,PMt,9,9,9,9,AMt)
c          
      call transpose9(RR4,2)
      call matxmat9(BMm,RR4,2,2,2,2,PMm)
      call transpose9(RR4,2)
      call matxmat9(RL4,PMm,2,2,2,2,AMm)
c          
      call transpose9(RR5,2)
      call matxmat9(BMn,RR5,2,2,2,2,PMn)
      call transpose9(RR5,2)
      call matxmat9(RL5,PMn,2,2,2,2,AMn)
c
      do i=1,9
         if (AMb(i,i).gt.0.d0)then
            do j=1,9
               RL1(i,j)=-RL1(i,j)
            enddo
         endif
      enddo
c     
      do i=1,9
         if (AMt(i,i).gt.0.d0)then
            do j=1,9
               RL2(i,j)=-RL2(i,j)
            enddo
         endif
      enddo
c
      do i=1,2
         if (AMm(i,i).gt.0.d0)then
            do j=1,2
               RL4(i,j)=-RL4(i,j)
            enddo
         endif
      enddo
c     
      do i=1,2
         if (AMn(i,i).gt.0.d0)then
            do j=1,2
               RL5(i,j)=-RL5(i,j)
            enddo
         endif
      enddo
c
c     final selection
c
      icha=int(cha)
      irow=int(row)
      icol=int(col)
      ipol=int(pol)
c     
      if(icha.eq.1)then
         if(ipol.eq.1)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RL1(1,1)
               elseif(icol.eq.2)then
                  biuni=RL1(1,2)
               elseif(icol.eq.3)then
                  biuni=RL1(1,3)
               elseif(icol.eq.4)then
                  biuni=RL1(1,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(1,5)
               elseif(icol.eq.6)then
                  biuni=RL1(1,6)
               elseif(icol.eq.7)then
                  biuni=RL1(1,7)
               elseif(icol.eq.8)then
                  biuni=RL1(1,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(1,9)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RL1(2,1)
               elseif(icol.eq.2)then
                  biuni=RL1(2,2)
               elseif(icol.eq.3)then
                  biuni=RL1(2,3)
               elseif(icol.eq.4)then
                  biuni=RL1(2,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(2,5)
               elseif(icol.eq.6)then
                  biuni=RL1(2,6)
               elseif(icol.eq.7)then
                  biuni=RL1(2,7)
               elseif(icol.eq.8)then
                  biuni=RL1(2,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(2,9)
               endif
            elseif(irow.eq.3)then
               if(icol.eq.1)then
                  biuni=RL1(3,1)
               elseif(icol.eq.2)then
                  biuni=RL1(3,2)
               elseif(icol.eq.3)then
                  biuni=RL1(3,3)
               elseif(icol.eq.4)then
                  biuni=RL1(3,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(3,5)
               elseif(icol.eq.6)then
                  biuni=RL1(3,6)
               elseif(icol.eq.7)then
                  biuni=RL1(3,7)
               elseif(icol.eq.8)then
                  biuni=RL1(3,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(3,9)
               endif
            elseif(irow.eq.4)then
               if(icol.eq.1)then
                  biuni=RL1(4,1)
               elseif(icol.eq.2)then
                  biuni=RL1(4,2)
               elseif(icol.eq.3)then
                  biuni=RL1(4,3)
               elseif(icol.eq.4)then
                  biuni=RL1(4,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(4,5)
               elseif(icol.eq.6)then
                  biuni=RL1(4,6)
               elseif(icol.eq.7)then
                  biuni=RL1(4,7)
               elseif(icol.eq.8)then
                  biuni=RL1(4,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(4,9)
               endif
            elseif(irow.eq.5)then  
               if(icol.eq.1)then
                  biuni=RL1(5,1)
               elseif(icol.eq.2)then
                  biuni=RL1(5,2)
               elseif(icol.eq.3)then
                  biuni=RL1(5,3)
               elseif(icol.eq.4)then
                  biuni=RL1(5,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(5,5)
               elseif(icol.eq.6)then
                  biuni=RL1(5,6)
               elseif(icol.eq.7)then
                  biuni=RL1(5,7)
               elseif(icol.eq.8)then
                  biuni=RL1(5,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(5,9)
               endif
            elseif(irow.eq.6)then
               if(icol.eq.1)then
                  biuni=RL1(6,1)
               elseif(icol.eq.2)then
                  biuni=RL1(6,2)
               elseif(icol.eq.3)then
                  biuni=RL1(6,3)
               elseif(icol.eq.4)then
                  biuni=RL1(6,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(6,5)
               elseif(icol.eq.6)then
                  biuni=RL1(6,6)
               elseif(icol.eq.7)then
                  biuni=RL1(6,7)
               elseif(icol.eq.8)then
                  biuni=RL1(6,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(6,9)
               endif
            elseif(irow.eq.7)then
               if(icol.eq.1)then
                  biuni=RL1(7,1)
               elseif(icol.eq.2)then
                  biuni=RL1(7,2)
               elseif(icol.eq.3)then
                  biuni=RL1(7,3)
               elseif(icol.eq.4)then
                  biuni=RL1(7,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(7,5)
               elseif(icol.eq.6)then
                  biuni=RL1(7,6)
               elseif(icol.eq.7)then
                  biuni=RL1(7,7)
               elseif(icol.eq.8)then
                  biuni=RL1(7,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(7,9)
               endif
            elseif(irow.eq.8)then
               if(icol.eq.1)then
                  biuni=RL1(8,1)
               elseif(icol.eq.2)then
                  biuni=RL1(8,2)
               elseif(icol.eq.3)then
                  biuni=RL1(8,3)
               elseif(icol.eq.4)then
                  biuni=RL1(8,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(8,5)
               elseif(icol.eq.6)then
                  biuni=RL1(8,6)
               elseif(icol.eq.7)then
                  biuni=RL1(8,7)
               elseif(icol.eq.8)then
                  biuni=RL1(8,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(8,9)
               endif
            elseif(irow.eq.9)then  
               if(icol.eq.1)then
                  biuni=RL1(9,1)
               elseif(icol.eq.2)then
                  biuni=RL1(9,2)
               elseif(icol.eq.3)then
                  biuni=RL1(9,3)
               elseif(icol.eq.4)then
                  biuni=RL1(9,4)
               elseif(icol.eq.5)then  
                  biuni=RL1(9,5)
               elseif(icol.eq.6)then
                  biuni=RL1(9,6)
               elseif(icol.eq.7)then
                  biuni=RL1(9,7)
               elseif(icol.eq.8)then
                  biuni=RL1(9,8)
               elseif(icol.eq.9)then  
                  biuni=RL1(9,9)
               endif
            endif
         elseif(ipol.eq.2)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RR1(1,1)
               elseif(icol.eq.2)then
                  biuni=RR1(1,2)
               elseif(icol.eq.3)then
                  biuni=RR1(1,3)
               elseif(icol.eq.4)then
                  biuni=RR1(1,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(1,5)
               elseif(icol.eq.6)then
                  biuni=RR1(1,6)
               elseif(icol.eq.7)then
                  biuni=RR1(1,7)
               elseif(icol.eq.8)then
                  biuni=RR1(1,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(1,9)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RR1(2,1)
               elseif(icol.eq.2)then
                  biuni=RR1(2,2)
               elseif(icol.eq.3)then
                  biuni=RR1(2,3)
               elseif(icol.eq.4)then
                  biuni=RR1(2,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(2,5)
               elseif(icol.eq.6)then
                  biuni=RR1(2,6)
               elseif(icol.eq.7)then
                  biuni=RR1(2,7)
               elseif(icol.eq.8)then
                  biuni=RR1(2,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(2,9)
               endif
            elseif(irow.eq.3)then
               if(icol.eq.1)then
                  biuni=RR1(3,1)
               elseif(icol.eq.2)then
                  biuni=RR1(3,2)
               elseif(icol.eq.3)then
                  biuni=RR1(3,3)
               elseif(icol.eq.4)then
                  biuni=RR1(3,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(3,5)
               elseif(icol.eq.6)then
                  biuni=RR1(3,6)
               elseif(icol.eq.7)then
                  biuni=RR1(3,7)
               elseif(icol.eq.8)then
                  biuni=RR1(3,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(3,9)
               endif
            elseif(irow.eq.4)then
               if(icol.eq.1)then
                  biuni=RR1(4,1)
               elseif(icol.eq.2)then
                  biuni=RR1(4,2)
               elseif(icol.eq.3)then
                  biuni=RR1(4,3)
               elseif(icol.eq.4)then
                  biuni=RR1(4,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(4,5)
               elseif(icol.eq.6)then
                  biuni=RR1(4,6)
               elseif(icol.eq.7)then
                  biuni=RR1(4,7)
               elseif(icol.eq.8)then
                  biuni=RR1(4,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(4,9)
               endif
            elseif(irow.eq.5)then  
               if(icol.eq.1)then
                  biuni=RR1(5,1)
               elseif(icol.eq.2)then
                  biuni=RR1(5,2)
               elseif(icol.eq.3)then
                  biuni=RR1(5,3)
               elseif(icol.eq.4)then
                  biuni=RR1(5,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(5,5)
               elseif(icol.eq.6)then
                  biuni=RR1(5,6)
               elseif(icol.eq.7)then
                  biuni=RR1(5,7)
               elseif(icol.eq.8)then
                  biuni=RR1(5,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(5,9)
               endif
            elseif(irow.eq.6)then
               if(icol.eq.1)then
                  biuni=RR1(6,1)
               elseif(icol.eq.2)then
                  biuni=RR1(6,2)
               elseif(icol.eq.3)then
                  biuni=RR1(6,3)
               elseif(icol.eq.4)then
                  biuni=RR1(6,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(6,5)
               elseif(icol.eq.6)then
                  biuni=RR1(6,6)
               elseif(icol.eq.7)then
                  biuni=RR1(6,7)
               elseif(icol.eq.8)then
                  biuni=RR1(6,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(6,9)
               endif
            elseif(irow.eq.7)then
               if(icol.eq.1)then
                  biuni=RR1(7,1)
               elseif(icol.eq.2)then
                  biuni=RR1(7,2)
               elseif(icol.eq.3)then
                  biuni=RR1(7,3)
               elseif(icol.eq.4)then
                  biuni=RR1(7,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(7,5)
               elseif(icol.eq.6)then
                  biuni=RR1(7,6)
               elseif(icol.eq.7)then
                  biuni=RR1(7,7)
               elseif(icol.eq.8)then
                  biuni=RR1(7,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(7,9)
               endif
            elseif(irow.eq.8)then
               if(icol.eq.1)then
                  biuni=RR1(8,1)
               elseif(icol.eq.2)then
                  biuni=RR1(8,2)
               elseif(icol.eq.3)then
                  biuni=RR1(8,3)
               elseif(icol.eq.4)then
                  biuni=RR1(8,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(8,5)
               elseif(icol.eq.6)then
                  biuni=RR1(8,6)
               elseif(icol.eq.7)then
                  biuni=RR1(8,7)
               elseif(icol.eq.8)then
                  biuni=RR1(8,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(8,9)
               endif
            elseif(irow.eq.9)then  
               if(icol.eq.1)then
                  biuni=RR1(9,1)
               elseif(icol.eq.2)then
                  biuni=RR1(9,2)
               elseif(icol.eq.3)then
                  biuni=RR1(9,3)
               elseif(icol.eq.4)then
                  biuni=RR1(9,4)
               elseif(icol.eq.5)then  
                  biuni=RR1(9,5)
               elseif(icol.eq.6)then
                  biuni=RR1(9,6)
               elseif(icol.eq.7)then
                  biuni=RR1(9,7)
               elseif(icol.eq.8)then
                  biuni=RR1(9,8)
               elseif(icol.eq.9)then  
                  biuni=RR1(9,9)
               endif
            endif
         endif
      elseif(icha.eq.2)then
         if(ipol.eq.1)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RL2(1,1)
               elseif(icol.eq.2)then
                  biuni=RL2(1,2)
               elseif(icol.eq.3)then
                  biuni=RL2(1,3)
               elseif(icol.eq.4)then
                  biuni=RL2(1,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(1,5)
               elseif(icol.eq.6)then
                  biuni=RL2(1,6)
               elseif(icol.eq.7)then
                  biuni=RL2(1,7)
               elseif(icol.eq.8)then
                  biuni=RL2(1,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(1,9)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RL2(2,1)
               elseif(icol.eq.2)then
                  biuni=RL2(2,2)
               elseif(icol.eq.3)then
                  biuni=RL2(2,3)
               elseif(icol.eq.4)then
                  biuni=RL2(2,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(2,5)
               elseif(icol.eq.6)then
                  biuni=RL2(2,6)
               elseif(icol.eq.7)then
                  biuni=RL2(2,7)
               elseif(icol.eq.8)then
                  biuni=RL2(2,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(2,9)
               endif
            elseif(irow.eq.3)then
               if(icol.eq.1)then
                  biuni=RL2(3,1)
               elseif(icol.eq.2)then
                  biuni=RL2(3,2)
               elseif(icol.eq.3)then
                  biuni=RL2(3,3)
               elseif(icol.eq.4)then
                  biuni=RL2(3,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(3,5)
               elseif(icol.eq.6)then
                  biuni=RL2(3,6)
               elseif(icol.eq.7)then
                  biuni=RL2(3,7)
               elseif(icol.eq.8)then
                  biuni=RL2(3,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(3,9)
               endif
            elseif(irow.eq.4)then
               if(icol.eq.1)then
                  biuni=RL2(4,1)
               elseif(icol.eq.2)then
                  biuni=RL2(4,2)
               elseif(icol.eq.3)then
                  biuni=RL2(4,3)
               elseif(icol.eq.4)then
                  biuni=RL2(4,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(4,5)
               elseif(icol.eq.6)then
                  biuni=RL2(4,6)
               elseif(icol.eq.7)then
                  biuni=RL2(4,7)
               elseif(icol.eq.8)then
                  biuni=RL2(4,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(4,9)
               endif
            elseif(irow.eq.5)then  
               if(icol.eq.1)then
                  biuni=RL2(5,1)
               elseif(icol.eq.2)then
                  biuni=RL2(5,2)
               elseif(icol.eq.3)then
                  biuni=RL2(5,3)
               elseif(icol.eq.4)then
                  biuni=RL2(5,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(5,5)
               elseif(icol.eq.6)then
                  biuni=RL2(5,6)
               elseif(icol.eq.7)then
                  biuni=RL2(5,7)
               elseif(icol.eq.8)then
                  biuni=RL2(5,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(5,9)
               endif
            elseif(irow.eq.6)then
               if(icol.eq.1)then
                  biuni=RL2(6,1)
               elseif(icol.eq.2)then
                  biuni=RL2(6,2)
               elseif(icol.eq.3)then
                  biuni=RL2(6,3)
               elseif(icol.eq.4)then
                  biuni=RL2(6,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(6,5)
               elseif(icol.eq.6)then
                  biuni=RL2(6,6)
               elseif(icol.eq.7)then
                  biuni=RL2(6,7)
               elseif(icol.eq.8)then
                  biuni=RL2(6,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(6,9)
               endif
            elseif(irow.eq.7)then
               if(icol.eq.1)then
                  biuni=RL2(7,1)
               elseif(icol.eq.2)then
                  biuni=RL2(7,2)
               elseif(icol.eq.3)then
                  biuni=RL2(7,3)
               elseif(icol.eq.4)then
                  biuni=RL2(7,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(7,5)
               elseif(icol.eq.6)then
                  biuni=RL2(7,6)
               elseif(icol.eq.7)then
                  biuni=RL2(7,7)
               elseif(icol.eq.8)then
                  biuni=RL2(7,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(7,9)
               endif
            elseif(irow.eq.8)then
               if(icol.eq.1)then
                  biuni=RL2(8,1)
               elseif(icol.eq.2)then
                  biuni=RL2(8,2)
               elseif(icol.eq.3)then
                  biuni=RL2(8,3)
               elseif(icol.eq.4)then
                  biuni=RL2(8,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(8,5)
               elseif(icol.eq.6)then
                  biuni=RL2(8,6)
               elseif(icol.eq.7)then
                  biuni=RL2(8,7)
               elseif(icol.eq.8)then
                  biuni=RL2(8,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(8,9)
               endif
            elseif(irow.eq.9)then  
               if(icol.eq.1)then
                  biuni=RL2(9,1)
               elseif(icol.eq.2)then
                  biuni=RL2(9,2)
               elseif(icol.eq.3)then
                  biuni=RL2(9,3)
               elseif(icol.eq.4)then
                  biuni=RL2(9,4)
               elseif(icol.eq.5)then  
                  biuni=RL2(9,5)
               elseif(icol.eq.6)then
                  biuni=RL2(9,6)
               elseif(icol.eq.7)then
                  biuni=RL2(9,7)
               elseif(icol.eq.8)then
                  biuni=RL2(9,8)
               elseif(icol.eq.9)then  
                  biuni=RL2(9,9)
               endif
            endif
         elseif(ipol.eq.2)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RR2(1,1)
               elseif(icol.eq.2)then
                  biuni=RR2(1,2)
               elseif(icol.eq.3)then
                  biuni=RR2(1,3)
               elseif(icol.eq.4)then
                  biuni=RR2(1,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(1,5)
               elseif(icol.eq.6)then
                  biuni=RR2(1,6)
               elseif(icol.eq.7)then
                  biuni=RR2(1,7)
               elseif(icol.eq.8)then
                  biuni=RR2(1,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(1,9)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RR2(2,1)
               elseif(icol.eq.2)then
                  biuni=RR2(2,2)
               elseif(icol.eq.3)then
                  biuni=RR2(2,3)
               elseif(icol.eq.4)then
                  biuni=RR2(2,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(2,5)
               elseif(icol.eq.6)then
                  biuni=RR2(2,6)
               elseif(icol.eq.7)then
                  biuni=RR2(2,7)
               elseif(icol.eq.8)then
                  biuni=RR2(2,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(2,9)
               endif
            elseif(irow.eq.3)then
               if(icol.eq.1)then
                  biuni=RR2(3,1)
               elseif(icol.eq.2)then
                  biuni=RR2(3,2)
               elseif(icol.eq.3)then
                  biuni=RR2(3,3)
               elseif(icol.eq.4)then
                  biuni=RR2(3,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(3,5)
               elseif(icol.eq.6)then
                  biuni=RR2(3,6)
               elseif(icol.eq.7)then
                  biuni=RR2(3,7)
               elseif(icol.eq.8)then
                  biuni=RR2(3,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(3,9)
               endif
            elseif(irow.eq.4)then
               if(icol.eq.1)then
                  biuni=RR2(4,1)
               elseif(icol.eq.2)then
                  biuni=RR2(4,2)
               elseif(icol.eq.3)then
                  biuni=RR2(4,3)
               elseif(icol.eq.4)then
                  biuni=RR2(4,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(4,5)
               elseif(icol.eq.6)then
                  biuni=RR2(4,6)
               elseif(icol.eq.7)then
                  biuni=RR2(4,7)
               elseif(icol.eq.8)then
                  biuni=RR2(4,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(4,9)
               endif
            elseif(irow.eq.5)then  
               if(icol.eq.1)then
                  biuni=RR2(5,1)
               elseif(icol.eq.2)then
                  biuni=RR2(5,2)
               elseif(icol.eq.3)then
                  biuni=RR2(5,3)
               elseif(icol.eq.4)then
                  biuni=RR2(5,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(5,5)
               elseif(icol.eq.6)then
                  biuni=RR2(5,6)
               elseif(icol.eq.7)then
                  biuni=RR2(5,7)
               elseif(icol.eq.8)then
                  biuni=RR2(5,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(5,9)
               endif
            elseif(irow.eq.6)then
               if(icol.eq.1)then
                  biuni=RR2(6,1)
               elseif(icol.eq.2)then
                  biuni=RR2(6,2)
               elseif(icol.eq.3)then
                  biuni=RR2(6,3)
               elseif(icol.eq.4)then
                  biuni=RR2(6,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(6,5)
               elseif(icol.eq.6)then
                  biuni=RR2(6,6)
               elseif(icol.eq.7)then
                  biuni=RR2(6,7)
               elseif(icol.eq.8)then
                  biuni=RR2(6,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(6,9)
               endif
            elseif(irow.eq.7)then
               if(icol.eq.1)then
                  biuni=RR2(7,1)
               elseif(icol.eq.2)then
                  biuni=RR2(7,2)
               elseif(icol.eq.3)then
                  biuni=RR2(7,3)
               elseif(icol.eq.4)then
                  biuni=RR2(7,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(7,5)
               elseif(icol.eq.6)then
                  biuni=RR2(7,6)
               elseif(icol.eq.7)then
                  biuni=RR2(7,7)
               elseif(icol.eq.8)then
                  biuni=RR2(7,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(7,9)
               endif
            elseif(irow.eq.8)then
               if(icol.eq.1)then
                  biuni=RR2(8,1)
               elseif(icol.eq.2)then
                  biuni=RR2(8,2)
               elseif(icol.eq.3)then
                  biuni=RR2(8,3)
               elseif(icol.eq.4)then
                  biuni=RR2(8,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(8,5)
               elseif(icol.eq.6)then
                  biuni=RR2(8,6)
               elseif(icol.eq.7)then
                  biuni=RR2(8,7)
               elseif(icol.eq.8)then
                  biuni=RR2(8,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(8,9)
               endif
            elseif(irow.eq.9)then  
               if(icol.eq.1)then
                  biuni=RR2(9,1)
               elseif(icol.eq.2)then
                  biuni=RR2(9,2)
               elseif(icol.eq.3)then
                  biuni=RR2(9,3)
               elseif(icol.eq.4)then
                  biuni=RR2(9,4)
               elseif(icol.eq.5)then  
                  biuni=RR2(9,5)
               elseif(icol.eq.6)then
                  biuni=RR2(9,6)
               elseif(icol.eq.7)then
                  biuni=RR2(9,7)
               elseif(icol.eq.8)then
                  biuni=RR2(9,8)
               elseif(icol.eq.9)then  
                  biuni=RR2(9,9)
               endif
            endif
         endif
      elseif(icha.eq.4)then
         if(ipol.eq.1)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RL4(1,1)
               elseif(icol.eq.2)then
                  biuni=RL4(1,2)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RL4(2,1)
               elseif(icol.eq.2)then
                  biuni=RL4(2,2)
               endif
            endif
         elseif(ipol.eq.2)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RR4(1,1)
               elseif(icol.eq.2)then
                  biuni=RR4(1,2)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RR4(2,1)
               elseif(icol.eq.2)then
                  biuni=RR4(2,2)
               endif
            endif
         endif
      elseif(icha.eq.5)then
         if(ipol.eq.1)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RL5(1,1)
               elseif(icol.eq.2)then
                  biuni=RL5(1,2)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RL5(2,1)
               elseif(icol.eq.2)then
                  biuni=RL5(2,2)
               endif
            endif
         elseif(ipol.eq.2)then
            if(irow.eq.1)then
               if(icol.eq.1)then
                  biuni=RR5(1,1)
               elseif(icol.eq.2)then
                  biuni=RR5(1,2)
               endif
            elseif(irow.eq.2)then
               if(icol.eq.1)then
                  biuni=RR5(2,1)
               elseif(icol.eq.2)then
                  biuni=RR5(2,2)
               endif
            endif
         endif
      endif
c     
      end
      
c     #######################
c     #####             #####
c     #####  ELEMENTS   #####
C     #####             #####
C     #######################
      SUBROUTINE BM9(BMb,BMt,BMm,BMn,GGG,FFF)
      double precision BMb(9,9), BMt(9,9),BMm(2,2), BMn(2,2)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT
C      
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c 
      do i=1,9
         do j=1,9
            BMb(i,j)=0.d0
            BMt(i,j)=0.d0
         enddo
      enddo
c 
      do i=1,2
         do j=1,2
            BMm(i,j)=0.d0
            BMn(i,j)=0.d0
         enddo
      enddo
c
      BMb(1,1)=0.d0
      BMb(1,2)=DTL
      BMb(1,3)=0.d0
      BMb(1,4)=DBL/2.d0 + (DBL*dcos(h/(2.d0*f)))/2.d0
      BMb(1,5)=0.d0
      BMb(1,6)=-DBL/2.d0 + (DBL*dcos(h/(2.d0*f)))/2.d0
      BMb(1,7)=0.d0
      BMb(1,8)=(DBL*dsin(h/(2.d0*f)))/dsqrt(2.d0)
      BMb(1,9)=0.d0
c 
      BMb(2,1)=0.d0
      BMb(2,2)=-mm
      BMb(2,3)=-MYT
      BMb(2,4)=0.d0
      BMb(2,5)=0.d0
      BMb(2,6)=0.d0
      BMb(2,7)=0.d0
      BMb(2,8)=0.d0
      BMb(2,9)=0.d0
c 
      BMb(3,1)=0.d0
      BMb(3,2)=0.d0
      BMb(3,3)=-mm
      BMb(3,4)=0.d0
      BMb(3,5)=0.d0
      BMb(3,6)=0.d0
      BMb(3,7)=0.d0
      BMb(3,8)=0.d0
      BMb(3,9)=0.d0
c 
      BMb(4,1)=0.d0
      BMb(4,2)=0.d0
      BMb(4,3)=0.d0
      BMb(4,4)=-mm
      BMb(4,5)=-MYB - (YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(4,6)=0.d0
      BMb(4,7)=-(YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(4,8)=0.d0
      BMb(4,9)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
c 
      BMb(5,1)=-((DBR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(5,2)=0.d0
      BMb(5,3)=0.d0
      BMb(5,4)=0.d0
      BMb(5,5)=-mm
      BMb(5,6)=0.d0
      BMb(5,7)=0.d0
      BMb(5,8)=0.d0
      BMb(5,9)=0.d0
c 
      BMb(6,1)=0.d0
      BMb(6,2)=0.d0
      BMb(6,3)=0.d0
      BMb(6,4)=0.d0
      BMb(6,5)=-(YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(6,6)=-mm
      BMb(6,7)=-MYB - (YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(6,8)=0.d0
      BMb(6,9)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
c 
      BMb(7,1)=-((DBR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(7,2)=0.d0
      BMb(7,3)=0.d0
      BMb(7,4)=0.d0
      BMb(7,5)=0.d0
      BMb(7,6)=0.d0
      BMb(7,7)=-mm
      BMb(7,8)=0.d0
      BMb(7,9)=0.d0
c 
      BMb(8,1)=0.d0
      BMb(8,2)=0.d0
      BMb(8,3)=0.d0
      BMb(8,4)=0.d0
      BMb(8,5)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(8,6)=0.d0
      BMb(8,7)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(8,8)=-mm
      BMb(8,9)=-MYB - YB*dcos(h/(2.d0*f))**2
c 
      BMb(9,1)=DBR*dcos(h/(2.d0*f))
      BMb(9,2)=0.d0
      BMb(9,3)=0.d0
      BMb(9,4)=0.d0
      BMb(9,5)=0.d0
      BMb(9,6)=0.d0
      BMb(9,7)=0.d0
      BMb(9,8)=0.d0
      BMb(9,9)=-mm
c
c
c
      BMt(1,1)=0.d0
      BMt(1,2)=-DTL/2.d0 + (DTL*dcos(h/(2.d0*f)))/2.d0
      BMt(1,3)=0.d0
      BMt(1,4)=DTL/2.d0 + (DTL*dcos(h/(2.d0*f)))/2.d0
      BMt(1,5)=0.d0
      BMt(1,6)=(DTL*dsin(h/(2.d0*f)))/dsqrt(2.d0)
      BMt(1,7)=0.d0
      BMt(1,8)=DBL
      BMt(1,9)=0.d0
c
      BMt(2,1)=0.d0
      BMt(2,2)=-mm
      BMt(2,3)=-MYT - (YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(2,4)=0.d0
      BMt(2,5)=-(YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(2,6)=0.d0
      BMt(2,7)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(2,8)=0.d0
      BMt(2,9)=0.d0
c
      BMt(3,1)=-((DTR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(3,2)=0.d0
      BMt(3,3)=-mm
      BMt(3,4)=0.d0
      BMt(3,5)=0.d0
      BMt(3,6)=0.d0
      BMt(3,7)=0.d0
      BMt(3,8)=0.d0
      BMt(3,9)=0.d0
c
      BMt(4,1)=0.d0
      BMt(4,2)=0.d0
      BMt(4,3)=-(YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(4,4)=-mm
      BMt(4,5)=-MYT - (YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(4,6)=0.d0
      BMt(4,7)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(4,8)=0.d0
      BMt(4,9)=0.d0
c
      BMt(5,1)=-((DTR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(5,2)=0.d0
      BMt(5,3)=0.d0
      BMt(5,4)=0.d0
      BMt(5,5)=-mm
      BMt(5,6)=0.d0
      BMt(5,7)=0.d0
      BMt(5,8)=0.d0
      BMt(5,9)=0.d0
c
      BMt(6,1)=0.d0
      BMt(6,2)=0.d0
      BMt(6,3)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(6,4)=0.d0
      BMt(6,5)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(6,6)=-mm
      BMt(6,7)=-MYT - YT*dcos(h/(2.d0*f))**2
      BMt(6,8)=0.d0
      BMt(6,9)=0.d0
c
      BMt(7,1)=DTR*dcos(h/(2.d0*f))
      BMt(7,2)=0.d0
      BMt(7,3)=0.d0
      BMt(7,4)=0.d0
      BMt(7,5)=0.d0
      BMt(7,6)=0.d0
      BMt(7,7)=-mm
      BMt(7,8)=0.d0
      BMt(7,9)=0.d0
c
      BMt(8,1)=0.d0
      BMt(8,2)=0.d0
      BMt(8,3)=0.d0
      BMt(8,4)=0.d0
      BMt(8,5)=0.d0
      BMt(8,6)=0.d0
      BMt(8,7)=0.d0
      BMt(8,8)=-mm
      BMt(8,9)=-MYB
c
      BMt(9,1)=0.d0
      BMt(9,2)=0.d0
      BMt(9,3)=0.d0
      BMt(9,4)=0.d0
      BMt(9,5)=0.d0
      BMt(9,6)=0.d0
      BMt(9,7)=0.d0
      BMt(9,8)=0.d0
      BMt(9,9)=-mm
C      
c
c
      BMm(1,1)=-mm
      BMm(1,2)=-MYB
      BMm(2,1)=0.d0
      BMm(2,2)=-mm
c
c
c
      BMn(1,1)=-mm
      BMn(1,2)=-MYT
      BMn(2,1)=0.d0
      BMn(2,2)=-mm
c
      END
c
      SUBROUTINE ELEMENTS9(BRN,BRC,BRL1,BRR1,BRL2,BRR2,
     ^     BRL4,BRR4,BRL5,BRR5,GGG,FFF)
      double precision BRN(6,6), BRC(4,4), BRL1(9,9), BRR1(9,9),
     ^     BRL2(9,9), BRR2(9,9), BRL4(2,2), BRR4(2,2),
     ^     BRL5(2,2), BRR5(2,2)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT
c
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      DO i=1,6
         DO j=1,6
            BRN(i,j)=0.d0
         ENDDO
      ENDDO
c
      BRN(1,1) = f**2*g0**2
      BRN(1,2) = 0.d0
      BRN(1,3) = -f**2*(g*g0/2.d0+1.d0/2.d0*g*g0*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2))
      BRN(1,4) = -f**2*(g*g0/(2.d0*DSQRT(2.d0))-g*g0*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(1,5) = -f**2*g*g0*DSIN(h/(2.d0*f))/DSQRT(2.d0)
      BRN(1,6) = -f**2*(g*g0/(2.d0*DSQRT(2.d0))-g*g0*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(2,2) = 2.d0*f**2*g0y**2
      BRN(2,3) = -f**2*(g*g0y/2.d0-1.d0/2.d0*g*g0y*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2))
      BRN(2,4) = -f**2*(3.d0*g*g0y/(2.d0*DSQRT(2.d0))+
     ^     g*g0y*DSQRT(1.d0-DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(2,5) = f**2*g*g0y*DSIN(h/(2.d0*f))/DSQRT(2.d0)
      BRN(2,6) = -f**2*(-g*g0y/(2.d0*DSQRT(2.d0))+g*g0y*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(3,3) = f**2*g**2+1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRN(3,4) = -f**2*g**2*DSIN(h/(2.d0*f))**2/(2.d0*DSQRT(2.d0))
      BRN(3,5) = f**2*g**2*DSIN(h/(2.d0*f))*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/DSQRT(2.d0)
      BRN(3,6) = -f**2*g**2*DSIN(h/(2.d0*f))**2/(2.d0*DSQRT(2.d0))
      BRN(4,4) = f**2*g**2+1.d0/4.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRN(4,5) = -1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)
      BRN(4,6) = 1.d0/4.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRN(5,5) =  f**2*g**2+f**2*g**2*(1.d0-DSIN(h/(2.d0*f))**2)
      BRN(5,6) = -1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)
      BRN(6,6) = f**2*g**2+1.d0/4.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
c
      DO i=1,6
         DO j=1,6
            BRN(j,i)=BRN(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,4
         DO j=1,4
            BRC(i,j)=0.d0
         ENDDO
      ENDDO
c
      BRC(1,1)=f**2*g0**2
      BRC(1,2)=-f**2*(g*g0/2.d0+1.d0/2.d0*g*g0*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2))
      BRC(1,3)=-f**2*(g*g0/2.d0-1.d0/2.d0*g*g0*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2))
      BRC(1,4)=-f**2*g*g0*DSIN(h/(2.d0*f))/DSQRT(2.D0)
      BRC(2,2)=f**2*g**2+1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRC(2,3)=-1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRC(2,4)=f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)/DSQRT(2.D0)
      BRC(3,3)=f**2*g**2+1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRC(3,4)=-f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)/DSQRT(2.D0)	
      BRC(4,4)=f**2*g**2+f**2*g**2*(1.d0-DSIN(h/(2.d0*f))**2)
c
      DO i=1,4
         DO j=1,4
            BRC(j,i)=BRC(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRL1(i,j)=0.d0
         ENDDO
      ENDDO
c
      BRL1(1,1)=DTL**2+(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2+
     ^     (DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2+
     ^     1.d0/2.d0*DBL**2*DSIN(h/(2.d0*f))**2 
      BRL1(1,2) = -mm*DTL 
      BRL1(1,3) = 0.d0 
      BRL1(1,4) = -mm*(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRL1(1,5) = 0.d0 
      BRL1(1,6) = -mm*(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRL1(1,7) = 0.d0 
      BRL1(1,8) = -((mm*DBL*DSIN(h/(2.d0*f)))/DSQRT(2.d0)) 
      BRL1(1,9) = 0.d0 
      BRL1(2,2) = mm**2+MYT**2 	
      BRL1(2,3) = mm*MYT 
      BRL1(2,4) = 0.d0 
      BRL1(2,5) = 0.d0 
      BRL1(2,6) = 0.d0 
      BRL1(2,7) = 0.d0 
      BRL1(2,8) = 0.d0 
      BRL1(2,9) = 0.d0 
      BRL1(3,3) = mm**2 
      BRL1(3,4) = 0.d0 
      BRL1(3,5) = 0.d0 
      BRL1(3,6) = 0.d0 
      BRL1(3,7) = 0.d0 
      BRL1(3,8) = 0.d0 
      BRL1(3,9) = 0.d0 
      BRL1(4,4) =mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRL1(4,5) =-mm*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2) 
      BRL1(4,6) =1.d0/2.d0*YB**2*DCOS(h/(2*f))**2*DSIN(h/(2.d0*f))**2-
     ^     YB*DSIN(h/(2.d0*f))**2*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2) 
      BRL1(4,7) =1.d0/2.d0*mm*YB*DSIN(h/(2.d0*f))**2
      BRL1(4,8) =-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YB**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-(YB*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRL1(4,9) =(mm*YB*DCOS(h/(2*f))*DSIN(h/(2*f)))/DSQRT(2.d0) 
      BRL1(5,5)=mm**2+1.d0/2.d0*DBR**2*DSIN(h/(2*f))**2 
      BRL1(5,6)=1.d0/2.d0*mm*YB*DSIN(h/(2*f))**2 
      BRL1(5,7)=1.d0/2.d0*DBR**2*DSIN(h/(2*f))**2 
      BRL1(5,8)=(mm*YB*DCOS(h/(2*f))*DSIN(h/(2*f)))/DSQRT(2.d0) 
      BRL1(5,9)=-((DBR**2*DCOS(h/(2*f))*DSIN(h/(2*f)))/DSQRT(2.d0)) 
      BRL1(6,6)=mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRL1(6,7)=-mm*(-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)
      BRL1(6,8)=-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YB**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-
     ^     (YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRL1(6,9)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRL1(7,7)=mm**2+1.d0/2.d0*DBR**2*DSIN(h/(2.d0*f))**2 
      BRL1(7,8)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRL1(7,9)=-((DBR**2*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/
     ^     DSQRT(2.d0)) 
      BRL1(8,8)=mm**2+(-MYB-YB*DCOS(h/(2.d0*f))**2)**2+YB**2*
     ^     DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2 
      BRL1(8,9)=-mm*(-MYB-YB*DCOS(h/(2.d0*f))**2) 
      BRL1(9,9)=mm**2+DBR**2*DCOS(h/(2.d0*f))**2
c     
      DO i=1,9
         DO j=1,9
            BRL1(j,i)=BRL1(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRR1(i,j)=0.d0
         ENDDO
      ENDDO
c	
      BRR1(1,1)=DBR**2*DCOS(h/(2.d0*f))**2+DBR**2*DSIN(h/(2.d0*f))**2 
      BRR1(1,2)= 0.d0 
      BRR1(1,3)= 0.d0 
      BRR1(1,4)= 0.d0 
      BRR1(1,5)=(mm*DBR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(1,6)= 0.d0 
      BRR1(1,7)=(mm*DBR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(1,8)= 0.d0 
      BRR1(1,9)=-mm*DBR*DCOS(h/(2.d0*f)) 
      BRR1(2,2)=mm**2+DTL**2 
      BRR1(2,3)=mm*MYT 
      BRR1(2,4)=DTL*(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRR1(2,5)= 0.d0 
      BRR1(2,6)=DTL*(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRR1(2,7)= 0.d0 
      BRR1(2,8)=(DBL*DTL*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(2,9)= 0.d0 
      BRR1(3,3)=mm**2+MYT**2 
      BRR1(3,4)= 0.d0 
      BRR1(3,5)= 0.d0 
      BRR1(3,6)= 0.d0 
      BRR1(3,7)= 0.d0 
      BRR1(3,8)= 0.d0 
      BRR1(3,9)= 0.d0 
      BRR1(4,4)=mm**2+(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2 
      BRR1(4,5)=-mm*(-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2) 
      BRR1(4,6)=(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))*
     ^     (DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRR1(4,7)=1.d0/2.d0*mm*YB*DSIN(h/(2.d0*f))**2 
      BRR1(4,8)=(DBL*(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(4,9)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(5,5)=mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRR1(5,6)=1.d0/2.d0*mm*YB*DSIN(h/(2.d0*f))**2 
      BRR1(5,7)=1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2-YB*DSIN(h/(2.d0*f))**2*(-MYB-
     ^     1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2) 
      BRR1(5,8)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(5,9)=-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YB**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-
     ^     (YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRR1(6,6)=mm**2+(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2 
      BRR1(6,7)=-mm*(-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2) 
      BRR1(6,8)=(DBL*(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(6,9)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(7,7)=mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRR1(7,8)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(7,9)=-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+
     ^(YB**2*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-
     ^     (YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRR1(8,8)=mm**2+1.d0/2.d0*DBL**2*DSIN(h/(2.d0*f))**2 
      BRR1(8,9)=-mm*(-MYB-YB*DCOS(h/(2.d0*f))**2) 
      BRR1(9,9)=mm**2+(-MYB-YB*DCOS(h/(2.d0*f))**2)**2+YB**2*
     ^     DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2
c     
      DO i=1,9
         DO j=1,9
            BRR1(j,i)=BRR1(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRL2(i,j)=0.d0
         ENDDO
      ENDDO
c	
      BRL2(1,1) = DBL**2+(-(DTL/2.d0)+1.d0/2.d0*DTL*
     ^     DCOS(h/(2.d0*f)))**2+(DTL/2.d0+1.d0/2.d0*
     ^     DTL*DCOS(h/(2.d0*f)))**2+1.d0/2.d0*DTL**2*DSIN(h/(2.d0*f))**2 
      BRL2(1,2) = -mm*(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRL2(1,3) = 0.d0 
      BRL2(1,4) = -mm*(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRL2(1,5) = 0.d0 
      BRL2(1,6) = -((mm*DTL*DSIN(h/(2.d0*f)))/DSQRT(2.D0)) 
      BRL2(1,7) = 0.d0 
      BRL2(1,8) = -mm*DBL 
      BRL2(1,9) = 0.d0 
      BRL2(2,2) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRL2(2,3) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRL2(2,4) = 1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2-YT*DSIN(h/(2.d0*f))**2*
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRL2(2,5) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRL2(2,6) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.D0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.D0))-
     ^     (YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.D0) 
      BRL2(2,7) =  (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(2,8) = 0.d0 
      BRL2(2,9) = 0.d0 
      BRL2(3,3) = mm**2+1.d0/2.d0*DTR**2*DSIN(h/(2.d0*f))**2 
      BRL2(3,4) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRL2(3,5) = 1.d0/2.d0*DTR**2*DSIN(h/(2.d0*f))**2 
      BRL2(3,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(3,7) = -((DTR**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.D0)) 
      BRL2(3,8) = 0.d0 
      BRL2(3,9) = 0.d0 
      BRL2(4,4) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRL2(4,5) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRL2(4,6) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.D0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.D0))-
     ^     (YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.D0) 
      BRL2(4,7) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(4,8) = 0.d0 
      BRL2(4,9) = 0.d0 
      BRL2(5,5) = mm**2+1.d0/2.d0*DTR**2*DSIN(h/(2.d0*f))**2 
      BRL2(5,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(5,7) = -((DTR**2*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/
     ^     DSQRT(2.D0)) 
      BRL2(5,8) = 0.d0 
      BRL2(5,9) = 0.d0 
      BRL2(6,6) = mm**2+(-MYT-YT*DCOS(h/(2.d0*f))**2)**2+
     ^     YT**2*DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2 
      BRL2(6,7) = -mm*(-MYT-YT*DCOS(h/(2.d0*f))**2) 
      BRL2(6,8) = 0.d0 
      BRL2(6,9) = 0.d0 
      BRL2(7,7) = mm**2+DTR**2*DCOS(h/(2.d0*f))**2 
      BRL2(7,8) = 0.d0 
      BRL2(7,9) = 0.d0 
      BRL2(8,8) = mm**2+MYB**2 
      BRL2(8,9) = mm*MYB 
      BRL2(9,9) = mm**2
c     
      DO i=1,9
         DO j=1,9
            BRL2(j,i)=BRL2(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRR2(i,j)=0.d0
         ENDDO
      ENDDO
c	
      BRR2(1,1) = DTR**2*DCOS(h/(2.d0*f))**2+DTR**2*DSIN(h/(2.d0*f))**2 
      BRR2(1,2) = 0.d0 
      BRR2(1,3) = (mm*DTR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(1,4) = 0.d0 
      BRR2(1,5) = (mm*DTR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(1,6) = 0.d0 
      BRR2(1,7) = -mm*DTR*DCOS(h/(2.d0*f)) 
      BRR2(1,8) = 0.d0 
      BRR2(1,9) = 0.d0 
      BRR2(2,2) = mm**2+(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))**2 
      BRR2(2,3) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRR2(2,4) = (-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))*
     ^     (DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRR2(2,5) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRR2(2,6) = (DTL*(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(2,7) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(2,8) = DBL*(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRR2(2,9) = 0.d0
      BRR2(3,3) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRR2(3,4) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRR2(3,5) = 1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2-YT*DSIN(h/(2.d0*f))**2*
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRR2(3,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(3,7) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-(YT*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2))/
     ^     DSQRT(2.d0) 
      BRR2(3,8) = 0.d0 
      BRR2(3,9) = 0.d0 
      BRR2(4,4) = mm**2+(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))**2 
      BRR2(4,5) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRR2(4,6) = (DTL*(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(4,7) =(mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(4,8) = DBL*(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRR2(4,9) = 0.d0 
      BRR2(5,5) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRR2(5,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(5,7) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-(YT*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2))/
     ^     DSQRT(2.d0) 
      BRR2(5,8) = 0.d0 
      BRR2(5,9) = 0.d0 
      BRR2(6,6)= mm**2+1.d0/2.d0*DTL**2*DSIN(h/(2.d0*f))**2 
      BRR2(6,7) = -mm*(-MYT-YT*DCOS(h/(2.d0*f))**2) 
      BRR2(6,8) =(DBL*DTL*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(6,9)= 0.d0 
      BRR2(7,7) = mm**2+(-MYT-YT*DCOS(h/(2.d0*f))**2)**2+YT**2*
     ^     DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2 
      BRR2(7,8)= 0.d0 
      BRR2(7,9)= 0.d0 
      BRR2(8,8)=mm**2+DBL**2 
      BRR2(8,9)=mm*MYB 
      BRR2(9,9)=mm**2+MYB**2
c     
      DO i=1,9
         DO j=1,9
            BRR2(j,i)=BRR2(i,j)
         ENDDO
      ENDDO
c
c
c
      BRL4(1,1)=mm**2 + MYB**2
      BRL4(1,2)=mm*MYB
      BRL4(2,1)=mm*MYB
      BRL4(2,2)=mm**2
c
      BRR4(1,1)=mm**2
      BRR4(1,2)=mm*MYB
      BRR4(2,1)=mm*MYB
      BRR4(2,2)=mm**2 + MYB**2
c
c
c
      BRL5(1,1)=mm**2 + MYT**2
      BRL5(1,2)=mm*MYT
      BRL5(2,1)=mm*MYT
      BRL5(2,2)=mm**2
c
      BRR5(1,1)=mm**2
      BRR5(1,2)=mm*MYT
      BRR5(2,1)=mm*MYT
      BRR5(2,2)=mm**2 + MYT**2
c
      END

c     #######################
c     #####             #####
c     #####  JACOBI     #####
C     #####             #####
C     #######################



      SUBROUTINE jacobi9(a,n,np,d,v,nrot)
      INTEGER n,np,nrot,NMAX
      DOUBLE PRECISION a(np,np),d(np),v(np,np)
      PARAMETER (NMAX=500)
C     Computes all eigenvalues and eigenvectors of a real symmetric 
c     matrix a, which is of size n by n, stored in a physical np by 
c     np array. On output, elements of a above the diagonal are 
c     destroyed. d returns the eigenvalues of a in its first n elements. 
c     v is a matrix with the same logical and physical dimensions as a, 
c     whose columns contain, on output, the normalized eigenvectors of a. 
c     nrot returns the number of Jacobi rotations that were required. 
      INTEGER i,ip,iq,j
      DOUBLE PRECISION c,g,h,s,sm,t,tau,theta,tresh,b(NMAX),z(NMAX)
      do ip=1,n
c     Initialize to the identity matrix.
         do iq=1,n
            v(ip,iq)=0.d0
         enddo
         v(ip,ip)=1.d0
      enddo
      do ip=1,n
         b(ip)=a(ip,ip)
c     Initialize b and d to the diagonal of a.
         d(ip)=b(ip)
         z(ip)=0.d0
c     This vector will accumulate terms of the form tapq
      enddo
c     as in equation (11.1.14).
      nrot=0
      do i=1,50
         sm=0.d0
         do ip=1,n-1
c     Sum off-diagonal elements.
            do iq=ip+1,n
               sm=sm+abs(a(ip,iq))
            enddo
         enddo
         if(sm.eq.0.d0)return
c     The normal return, which relies on quadratic conver-
         if(i.lt.4)then
c     gence to machine underflow.
            tresh=0.2d0*sm/n**2
c     ...on the first three sweeps.
         else
            tresh=0.d0
c     ...thereafter.
         endif
         do ip=1,n-1
            do iq=ip+1,n
               g=100.d0*abs(a(ip,iq))
c     After four sweeps, skip the rotation if the off-diagonal element is small.
               if((i.gt.4).and.(abs(d(ip))+g.eq.abs(d(ip)))
     ^              .and.(abs(d(iq))+g.eq.abs(d(iq))))then
               a(ip,iq)=0.d0
            else if(abs(a(ip,iq)).gt.tresh)then
               h=d(iq)-d(ip)
               if(abs(h)+g.eq.abs(h))then
                  t=a(ip,iq)/h
c     t = 1/(2θ)
               else
                  theta=0.5d0*h/a(ip,iq)
c     Equation (11.1.10).
                  t=1.d0/(abs(theta)+sqrt(1.d0+theta**2))
                  if(theta.lt.0.d0)t=-t
               endif
               c=1.d0/sqrt(1+t**2)
               s=t*c
               tau=s/(1.d0+c)
               h=t*a(ip,iq)
               z(ip)=z(ip)-h
               z(iq)=z(iq)+h
               d(ip)=d(ip)-h
               d(iq)=d(iq)+h
               a(ip,iq)=0.d0
               do j=1,ip-1
c     Case of rotations 1 ≤ j < p.
                  g=a(j,ip)
                  h=a(j,iq)
                  a(j,ip)=g-s*(h+g*tau)
                  a(j,iq)=h+s*(g-h*tau)
               enddo
               do j=ip+1,iq-1
c     Case of rotations p < j < q.
                  g=a(ip,j)
                  h=a(j,iq)
                  a(ip,j)=g-s*(h+g*tau)
                  a(j,iq)=h+s*(g-h*tau)
               enddo
               do j=iq+1,n
c     Case of rotations q < j ≤ n.
                  g=a(ip,j)
                  h=a(iq,j)
                  a(ip,j)=g-s*(h+g*tau)
                  a(iq,j)=h+s*(g-h*tau)
               enddo
               do j=1,n
                  g=v(j,ip)
                  h=v(j,iq)
                  v(j,ip)=g-s*(h+g*tau)
                  v(j,iq)=h+s*(g-h*tau)
               enddo
               nrot=nrot+1
            endif
         enddo
      enddo
      do ip=1,n
         b(ip)=b(ip)+z(ip)
         d(ip)=b(ip)
c     Update d with the sum of tapq ,
         z(ip)=0.d0
c     and reinitialize z.
      enddo
      enddo
c     pause ’too many iterations in jacobi’
      return
      END


c     #######################
c     #####             #####
c     #####  EIGENSRT   #####
C     #####             #####
C     #######################


c
      SUBROUTINE eigsrt9(d,v,n,np)
      INTEGER n,np
      DOUBLE PRECISION d(np),v(np,np)
c     Given the eigenvalues d and eigenvectors v as output from 
c     jacobi, this routine sorts the eigenvalues into ascending 
c     order, and rearranges the columns of v correspondingly. The 
c     method is straight insertion.
      INTEGER i,j,k
      DOUBLE PRECISION p
      do i=1,n-1
         k=i
         p=d(i)
         do j=i+1,n
            if(d(j).le.p)then
               k=j
               p=d(j)
            endif
         enddo
         if(k.ne.i)then
            d(k)=d(i)
            d(i)=p
            do j=1,n
               p=v(j,i)
               v(j,i)=v(j,k)
               v(j,k)=p
            enddo
         endif
      enddo
      return
      END
c
      SUBROUTINE transpose9(mat,n)
      DOUBLE PRECISION mat(n,n), aux(n,n)
      INTEGER i,j,n
c
      do i=1,n
         do j=1,n
            aux(i,j)=mat(j,i)
         enddo
      enddo
c
      do i=1,n
         do j=1,n
            mat(i,j)=aux(i,j)
         enddo
      enddo
c
      return
      END
c===================================
C Subroutine per il calcolo del prodotto matrice - matrice
C====================================================================
      SUBROUTINE matxmat9(A,B,n,m,r,maxdim,C)
      IMPLICIT NONE
C
C Variabili INGRESSO:
C     A       matrice n righe ed m colonne
C     B       matrice m righe ed r colonne
C     n       numero di righe di A e numero di righe di C
C     m       numero di colonne di A e numero di righe di B
C     r       numero di colonne di B e numero di colonne di C
C     maxdim  numero massimo di righe di A, B, C (come da 
C             dimensionamento)
C
C Variabili USCITA:
C     C       matrice prodotto n righe ed r colonne
C
C====================
C Parte dichiarativa
C====================
      INTEGER n, m, r, maxdim
      INTEGER i, j, k
      REAL*8 A(1:maxdim,*), B(1:maxdim,*), C(1:maxdim,*)
      REAL*8 acc
C====================
C Parte esecutiva
C====================
      do i = 1, n
        do j = 1, r
	  acc = 0.0d0
	  do k = 1, m
             acc = acc + A(i,k)*B(k,j)
	  end do
	  C(i,j) = acc
        end do
      end do
      return
      end
