      double precision function htogg(gg1,gg2,gg3,gg4,gg5,
     ^     ff1,ff2,ff3,ff4,ff5,ff6,ff7,ff8,ff9,massh)
c...  
c...  H \to gg in a MCHM
c     authors: G. M. Pruna, D. Barducci
c...  
c     
      implicit none 
c     
#include "looptools.h"
c
      double precision ramb,iamb,ramt,iamt,ramw,iamw
      double precision Mb0,Mb1,Mb2,Mb02,Mb12,Mb22,
     ^     Mt0,Mt1,Mt2,Mt02,Mt12,Mt22,
     ^     Mw0,Mw02,ram,iam,
     ^     MH,MH2,MZ1,MZ12,Sqrt2,reM12,imM12,reM1,imM1
      double precision rC0b,iC0b,rC0t,iC0t,rC0w,iC0w
      double precision PI,Nc,
     ^     cHBb(9),cZ1Bb(9),
     ^     aHBb(9),aZ1Bb(9),
     ^     bHBb(9),bZ1Bb(9),
     ^     cHTt(9),cZ1Tt(9),
     ^     aHTt(9),aZ1Tt(9),
     ^     bHTt(9),bZ1Tt(9),
     ^     cHWW(4),cZ1WW(4),
     ^     aHWW(4),aZ1WW(4),
     ^     bHWW(4),bZ1WW(4),
     ^     B(28803),
     ^     ccc_b, ccc_t, ccc_w
      double precision GGG(6),FFF(9),
     ^     gg1,gg2,gg3,gg4,gg5,
     ^     ff1,ff2,ff3,ff4,ff5,ff6,ff7,ff8,ff9,massh,
     ^     f,g,g0,g0y,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT
      double precision BRN(6,6), BRC(4,4), BRL1(9,9), BRR1(9,9),
     ^     BRL2(9,9), BRR2(9,9), MZ(6), MZ6, MW(4),Mb(9),Mt(9),
     ^     RN(6,6), RC(4,4), RL1(9,9), RR1(9,9),
     ^     RL2(9,9), RR2(9,9), checkMb(9), checkMt(9)
      integer i,j,k, nr, theCt,theCb,theCw
      double precision BMb(9,9),BMt(9,9),AMb(9,9),AMt(9,9),
     ^     PMb(9,9),PMt(9,9)
c      double precision htogg
c     
      do i=1,9
         do j=1,9
            BMb(i,j)=0.d0
            BMt(i,j)=0.d0
            AMb(i,j)=0.d0
            AMt(i,j)=0.d0
            PMb(i,j)=0.d0
            PMt(i,j)=0.d0
         enddo
      enddo
c
      nr=0
      Nc=1.d0
      Sqrt2=dsqrt(2.d0)
c
c      f=1000.d0
c      g=2.d0
c      g0=0.6850942027571492d0
c      g0y=0.3682209383687254d0
c      h=248.776652778776d0
c      GG=1.117d0
c     
c      mm=1854.3693821959773d0
c      DBL=283.9827695372886d0
c      DBR=435.54656453885343d0
c      DTL=3115.0753186071656d0
c      DTR=1559.5054017365655d0
c      YB=973.816925803618d0
c      YT=2283.8094489113673d0
c      MYB=-3007.6408806541453d0
c      MYT= -1620.7390489142188d0     
c
      f=gg4
      g=gg2
      g0=gg1
      g0y=gg3
      h=gg5
      GG=1.117d0
c     
      mm=ff1
      DBL=ff2
      DBR=ff3
      DTL=ff4
      DTR=ff5
      YB=ff6
      YT=ff7
      MYB=ff8
      MYT=ff9
c     
      GGG(1)=f
      GGG(2)=g
      GGG(3)=g0
      GGG(4)=g0y
      GGG(5)=h
      GGG(6)=GG
c     
      FFF(1)=mm
      FFF(2)=DBL
      FFF(3)=DBR
      FFF(4)=DTL
      FFF(5)=DTR
      FFF(6)=YB
      FFF(7)=YT
      FFF(8)=MYB
      FFF(9)=MYT
c
c      MH=125.07094640500708d0
      MH=massh
      MH2=MH**2
c     
      call elements2(BRN,BRC,BRL1,BRR1,BRL2,BRR2,GGG,FFF)
      call BM2(BMb,BMt,GGG,FFF)
c     
      call jacobi2(BRN,6,6,MZ,RN,nr)
      call eigsrt2(MZ,RN,6,6)
      call transpose2(RN,6)
      do i=1,6
         MZ(i)=dsqrt(dabs(MZ(i)))
      enddo
c     
      call jacobi2(BRC,4,4,MW,RC,nr)
      call eigsrt2(MW,RC,4,4)
      call transpose2(RC,4)
      do i=1,4
         MW(i)=dsqrt(dabs(MW(i)))
      enddo
c     
      call jacobi2(BRL1,9,9,Mb,RL1,nr)
      call eigsrt2(Mb,RL1,9,9)
      call transpose2(RL1,9)
      do i=1,9
         Mb(i)=dsqrt(dabs(Mb(i)))
      enddo
c     
      call jacobi2(BRR1,9,9,checkMb,RR1,nr)
      call eigsrt2(checkMb,RR1,9,9)
      call transpose2(RR1,9)
c     
      call jacobi2(BRL2,9,9,Mt,RL2,nr)
      call eigsrt2(Mt,RL2,9,9)
      call transpose2(RL2,9)
      do i=1,9
         Mt(i)=dsqrt(dabs(Mt(i)))
      enddo
c     
      call jacobi2(BRR2,9,9,checkMt,RR2,nr)
      call eigsrt2(checkMt,RR2,9,9)
      call transpose2(RR2,9)
c     
c     Adjusting the signs
c     
      call transpose2(RR1,9)
      call matxmat2(BMb,RR1,9,9,9,9,PMb)
      call transpose2(RR1,9)
      call matxmat2(RL1,PMb,9,9,9,9,AMb)
c     
      call transpose2(RR2,9)
      call matxmat2(BMt,RR2,9,9,9,9,PMt)
      call transpose2(RR2,9)
      call matxmat2(RL2,PMt,9,9,9,9,AMt)
c     
      do i=1,9
         if (AMb(i,i).gt.0.d0)then
            do j=1,9
               RL1(i,j)=-RL1(i,j)
            enddo
         endif
      enddo
c     c      
      do i=1,9
         if (AMt(i,i).gt.0.d0)then
            do j=1,9
               RL2(i,j)=-RL2(i,j)
            enddo
         endif
      enddo
c     
c     
c     
      PI=dacos(-1.d0)
      MZ1=MZ(1)
      MZ12=MZ1**2
c     
      call barrow2(B,RN,RC,RL1,RR1,RL2,RR2,GGG,FFF)
c     
      call ccoupb2(GGG,FFF,cHBb,cZ1Bb)
      call hcoupb2(GGG,FFF,aHBb,B)
      call zcoupb2(GGG,FFF,aZ1Bb,B)
c     
      call ccoupt2(GGG,FFF,cHTt,cZ1Tt)
      call hcoupt2(GGG,FFF,aHTt,B)
      call zcoupt2(GGG,FFF,aZ1Tt,B)
c     
      call ccoupw2(GGG,FFF,cHWW,cZ1WW)
      call hcoupw2(GGG,FFF,aHWW,B)
      call zcoupw2(GGG,FFF,aZ1WW,B)
c     
      ram=0.d0
      iam=0.d0
c     
      call ltini
c     
      do j=1,9
c     
         Mb0=Mb(j)
         Mb02=Mb0**2
c     
         Mt0=Mt(j)
         Mt02=Mt0**2
c     
         theCb=Cget(0.d0,0.d0,MH2,Mb02,Mb02,Mb02)
         theCt=Cget(0.d0,0.d0,MH2,Mt02,Mt02,Mt02)
c     
         rC0b=real(Cval(cc0,theCb))
         rC0t=real(Cval(cc0,theCt))
         iC0b=aimag(Cval(cc0,theCb))
         iC0t=aimag(Cval(cc0,theCt))
c     
         ccc_b=(3.d0)**2*Nc*(2.d0*Mb0*cZ1Bb(j)**2*aZ1Bb(j)**2*
     ^        cHBb(j)*aHBb(j))/PI**2/MH2
c     
         ccc_t=(3.d0/2.d0)**2*Nc*(2.d0*Mt0*cZ1Tt(j)**2*aZ1Tt(j)**2*
     ^        cHTt(j)*aHTt(j))/PI**2/MH2
c     
         ramb=ccc_b*(  2.D0 + 4.D0*rC0b*Mb02 - rC0b*MH2 )
         iamb=ccc_b*(  4.D0*iC0b*Mb02 - iC0b*MH2 )
c     
         ramt=ccc_t*(  2.D0 + 4.D0*rC0t*Mt02 - rC0t*MH2 )
         iamt=ccc_t*(  4.D0*iC0t*Mt02 - iC0t*MH2 )
c     
         if (j.lt.5) then
            Mw0=MW(j)
            Mw02=Mw0**2
            theCw=Cget(0.d0,0.d0,MH2,Mw02,Mw02,Mw02)
            rC0w=real(Cval(cc0,theCw))
            iC0w=aimag(Cval(cc0,theCw))
            ccc_w=cZ1WW(j)**2*aZ1WW(j)**2*cHWW(j)*aHWW(j)/
     ^           8.d0/MH2/PI**2
c     
            ramw=ccc_w*( 6.D0 + MH2/Mw02 + 12.D0*rC0w*
     &           Mw02 - 6.D0*rC0w*MH2 )
            iamw=ccc_w*( 12.D0*iC0w*
     &           Mw02 - 6.D0*iC0w*MH2 )
            ramw=0.d0
            iamw=0.d0
         else
            ramw=0.d0
            iamw=0.d0
         endif
c     
c         print*, ramb,ramt,ramw
         ram=ram+ramb+ramt+ramw
         iam=iam+iamb+iamt+iamw
      enddo
c     
      call ltexi
c     
      htogg=dsqrt(ram**2+iam**2)  
c      print*, htogg
c     
      end
      
c     #######################
c     #####             #####
c     #####  ELEMENTS   #####
C     #####             #####
C     #######################

      SUBROUTINE BM2(BMb,BMt,GGG,FFF)
      double precision BMb(9,9), BMt(9,9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT
C      
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c 
      do i=1,9
         do j=1,9
            BMb(i,j)=0.d0
            BMt(i,j)=0.d0
         enddo
      enddo
c
      BMb(1,1)=0.d0
      BMb(1,2)=DTL
      BMb(1,3)=0.d0
      BMb(1,4)=DBL/2.d0 + (DBL*dcos(h/(2.d0*f)))/2.d0
      BMb(1,5)=0.d0
      BMb(1,6)=-DBL/2.d0 + (DBL*dcos(h/(2.d0*f)))/2.d0
      BMb(1,7)=0.d0
      BMb(1,8)=(DBL*dsin(h/(2.d0*f)))/dsqrt(2.d0)
      BMb(1,9)=0.d0
c 
      BMb(2,1)=0.d0
      BMb(2,2)=-mm
      BMb(2,3)=-MYT
      BMb(2,4)=0.d0
      BMb(2,5)=0.d0
      BMb(2,6)=0.d0
      BMb(2,7)=0.d0
      BMb(2,8)=0.d0
      BMb(2,9)=0.d0
c 
      BMb(3,1)=0.d0
      BMb(3,2)=0.d0
      BMb(3,3)=-mm
      BMb(3,4)=0.d0
      BMb(3,5)=0.d0
      BMb(3,6)=0.d0
      BMb(3,7)=0.d0
      BMb(3,8)=0.d0
      BMb(3,9)=0.d0
c 
      BMb(4,1)=0.d0
      BMb(4,2)=0.d0
      BMb(4,3)=0.d0
      BMb(4,4)=-mm
      BMb(4,5)=-MYB - (YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(4,6)=0.d0
      BMb(4,7)=-(YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(4,8)=0.d0
      BMb(4,9)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
c 
      BMb(5,1)=-((DBR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(5,2)=0.d0
      BMb(5,3)=0.d0
      BMb(5,4)=0.d0
      BMb(5,5)=-mm
      BMb(5,6)=0.d0
      BMb(5,7)=0.d0
      BMb(5,8)=0.d0
      BMb(5,9)=0.d0
c 
      BMb(6,1)=0.d0
      BMb(6,2)=0.d0
      BMb(6,3)=0.d0
      BMb(6,4)=0.d0
      BMb(6,5)=-(YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(6,6)=-mm
      BMb(6,7)=-MYB - (YB*dsin(h/(2.d0*f))**2)/2.d0
      BMb(6,8)=0.d0
      BMb(6,9)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
c 
      BMb(7,1)=-((DBR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(7,2)=0.d0
      BMb(7,3)=0.d0
      BMb(7,4)=0.d0
      BMb(7,5)=0.d0
      BMb(7,6)=0.d0
      BMb(7,7)=-mm
      BMb(7,8)=0.d0
      BMb(7,9)=0.d0
c 
      BMb(8,1)=0.d0
      BMb(8,2)=0.d0
      BMb(8,3)=0.d0
      BMb(8,4)=0.d0
      BMb(8,5)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(8,6)=0.d0
      BMb(8,7)=-((YB*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMb(8,8)=-mm
      BMb(8,9)=-MYB - YB*dcos(h/(2.d0*f))**2
c 
      BMb(9,1)=DBR*dcos(h/(2.d0*f))
      BMb(9,2)=0.d0
      BMb(9,3)=0.d0
      BMb(9,4)=0.d0
      BMb(9,5)=0.d0
      BMb(9,6)=0.d0
      BMb(9,7)=0.d0
      BMb(9,8)=0.d0
      BMb(9,9)=-mm
c
c
c
      BMt(1,1)=0.d0
      BMt(1,2)=-DTL/2.d0 + (DTL*dcos(h/(2.d0*f)))/2.d0
      BMt(1,3)=0.d0
      BMt(1,4)=DTL/2.d0 + (DTL*dcos(h/(2.d0*f)))/2.d0
      BMt(1,5)=0.d0
      BMt(1,6)=(DTL*dsin(h/(2.d0*f)))/dsqrt(2.d0)
      BMt(1,7)=0.d0
      BMt(1,8)=DBL
      BMt(1,9)=0.d0
c
      BMt(2,1)=0.d0
      BMt(2,2)=-mm
      BMt(2,3)=-MYT - (YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(2,4)=0.d0
      BMt(2,5)=-(YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(2,6)=0.d0
      BMt(2,7)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(2,8)=0.d0
      BMt(2,9)=0.d0
c
      BMt(3,1)=-((DTR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(3,2)=0.d0
      BMt(3,3)=-mm
      BMt(3,4)=0.d0
      BMt(3,5)=0.d0
      BMt(3,6)=0.d0
      BMt(3,7)=0.d0
      BMt(3,8)=0.d0
      BMt(3,9)=0.d0
c
      BMt(4,1)=0.d0
      BMt(4,2)=0.d0
      BMt(4,3)=-(YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(4,4)=-mm
      BMt(4,5)=-MYT - (YT*dsin(h/(2.d0*f))**2)/2.d0
      BMt(4,6)=0.d0
      BMt(4,7)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(4,8)=0.d0
      BMt(4,9)=0.d0
c
      BMt(5,1)=-((DTR*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(5,2)=0.d0
      BMt(5,3)=0.d0
      BMt(5,4)=0.d0
      BMt(5,5)=-mm
      BMt(5,6)=0.d0
      BMt(5,7)=0.d0
      BMt(5,8)=0.d0
      BMt(5,9)=0.d0
c
      BMt(6,1)=0.d0
      BMt(6,2)=0.d0
      BMt(6,3)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(6,4)=0.d0
      BMt(6,5)=-((YT*dcos(h/(2.d0*f))*dsin(h/(2.d0*f)))/dsqrt(2.d0))
      BMt(6,6)=-mm
      BMt(6,7)=-MYT - YT*dcos(h/(2.d0*f))**2
      BMt(6,8)=0.d0
      BMt(6,9)=0.d0
c
      BMt(7,1)=DTR*dcos(h/(2.d0*f))
      BMt(7,2)=0.d0
      BMt(7,3)=0.d0
      BMt(7,4)=0.d0
      BMt(7,5)=0.d0
      BMt(7,6)=0.d0
      BMt(7,7)=-mm
      BMt(7,8)=0.d0
      BMt(7,9)=0.d0
c
      BMt(8,1)=0.d0
      BMt(8,2)=0.d0
      BMt(8,3)=0.d0
      BMt(8,4)=0.d0
      BMt(8,5)=0.d0
      BMt(8,6)=0.d0
      BMt(8,7)=0.d0
      BMt(8,8)=-mm
      BMt(8,9)=-MYB
c
      BMt(9,1)=0.d0
      BMt(9,2)=0.d0
      BMt(9,3)=0.d0
      BMt(9,4)=0.d0
      BMt(9,5)=0.d0
      BMt(9,6)=0.d0
      BMt(9,7)=0.d0
      BMt(9,8)=0.d0
      BMt(9,9)=-mm
C      
      END

      SUBROUTINE ELEMENTS2(BRN, BRC, BRL1, BRR1, BRL2, BRR2,GGG,FFF)
      double precision BRN(6,6), BRC(4,4), BRL1(9,9), BRR1(9,9),
     ^     BRL2(9,9), BRR2(9,9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT
c
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      DO i=1,6
         DO j=1,6
            BRN(i,j)=0.d0
         ENDDO
      ENDDO
c
      BRN(1,1) = f**2*g0**2
      BRN(1,2) = 0.d0
      BRN(1,3) = -f**2*(g*g0/2.d0+1.d0/2.d0*g*g0*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2))
      BRN(1,4) = -f**2*(g*g0/(2.d0*DSQRT(2.d0))-g*g0*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(1,5) = -f**2*g*g0*DSIN(h/(2.d0*f))/DSQRT(2.d0)
      BRN(1,6) = -f**2*(g*g0/(2.d0*DSQRT(2.d0))-g*g0*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(2,2) = 2.d0*f**2*g0y**2
      BRN(2,3) = -f**2*(g*g0y/2.d0-1.d0/2.d0*g*g0y*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2))
      BRN(2,4) = -f**2*(3.d0*g*g0y/(2.d0*DSQRT(2.d0))+
     ^     g*g0y*DSQRT(1.d0-DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(2,5) = f**2*g*g0y*DSIN(h/(2.d0*f))/DSQRT(2.d0)
      BRN(2,6) = -f**2*(-g*g0y/(2.d0*DSQRT(2.d0))+g*g0y*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/(2.d0*DSQRT(2.d0)))
      BRN(3,3) = f**2*g**2+1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRN(3,4) = -f**2*g**2*DSIN(h/(2.d0*f))**2/(2.d0*DSQRT(2.d0))
      BRN(3,5) = f**2*g**2*DSIN(h/(2.d0*f))*DSQRT(1.d0-
     ^     DSIN(h/(2.d0*f))**2)/DSQRT(2.d0)
      BRN(3,6) = -f**2*g**2*DSIN(h/(2.d0*f))**2/(2.d0*DSQRT(2.d0))
      BRN(4,4) = f**2*g**2+1.d0/4.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRN(4,5) = -1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)
      BRN(4,6) = 1.d0/4.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRN(5,5) =  f**2*g**2+f**2*g**2*(1.d0-DSIN(h/(2.d0*f))**2)
      BRN(5,6) = -1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)
      BRN(6,6) = f**2*g**2+1.d0/4.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
c
      DO i=1,6
         DO j=1,6
            BRN(j,i)=BRN(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,4
         DO j=1,4
            BRC(i,j)=0.d0
         ENDDO
      ENDDO
c
      BRC(1,1)=f**2*g0**2
      BRC(1,2)=-f**2*(g*g0/2.d0+1.d0/2.d0*g*g0*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2))
      BRC(1,3)=-f**2*(g*g0/2.d0-1.d0/2.d0*g*g0*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2))
      BRC(1,4)=-f**2*g*g0*DSIN(h/(2.d0*f))/DSQRT(2.D0)
      BRC(2,2)=f**2*g**2+1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRC(2,3)=-1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRC(2,4)=f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)/DSQRT(2.D0)
      BRC(3,3)=f**2*g**2+1.d0/2.d0*f**2*g**2*DSIN(h/(2.d0*f))**2
      BRC(3,4)=-f**2*g**2*DSIN(h/(2.d0*f))*
     ^     DSQRT(1.d0-DSIN(h/(2.d0*f))**2)/DSQRT(2.D0)	
      BRC(4,4)=f**2*g**2+f**2*g**2*(1.d0-DSIN(h/(2.d0*f))**2)
c
      DO i=1,4
         DO j=1,4
            BRC(j,i)=BRC(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRL1(i,j)=0.d0
         ENDDO
      ENDDO
c
      BRL1(1,1)=DTL**2+(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2+
     ^     (DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2+
     ^     1.d0/2.d0*DBL**2*DSIN(h/(2.d0*f))**2 
      BRL1(1,2) = -mm*DTL 
      BRL1(1,3) = 0.d0 
      BRL1(1,4) = -mm*(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRL1(1,5) = 0.d0 
      BRL1(1,6) = -mm*(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRL1(1,7) = 0.d0 
      BRL1(1,8) = -((mm*DBL*DSIN(h/(2.d0*f)))/DSQRT(2.d0)) 
      BRL1(1,9) = 0.d0 
      BRL1(2,2) = mm**2+MYT**2 	
      BRL1(2,3) = mm*MYT 
      BRL1(2,4) = 0.d0 
      BRL1(2,5) = 0.d0 
      BRL1(2,6) = 0.d0 
      BRL1(2,7) = 0.d0 
      BRL1(2,8) = 0.d0 
      BRL1(2,9) = 0.d0 
      BRL1(3,3) = mm**2 
      BRL1(3,4) = 0.d0 
      BRL1(3,5) = 0.d0 
      BRL1(3,6) = 0.d0 
      BRL1(3,7) = 0.d0 
      BRL1(3,8) = 0.d0 
      BRL1(3,9) = 0.d0 
      BRL1(4,4) =mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRL1(4,5) =-mm*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2) 
      BRL1(4,6) =1.d0/2.d0*YB**2*DCOS(h/(2*f))**2*DSIN(h/(2.d0*f))**2-
     ^     YB*DSIN(h/(2.d0*f))**2*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2) 
      BRL1(4,7) =1.d0/2.d0*mm*YB*DSIN(h/(2.d0*f))**2
      BRL1(4,8) =-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YB**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-(YB*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRL1(4,9) =(mm*YB*DCOS(h/(2*f))*DSIN(h/(2*f)))/DSQRT(2.d0) 
      BRL1(5,5)=mm**2+1.d0/2.d0*DBR**2*DSIN(h/(2*f))**2 
      BRL1(5,6)=1.d0/2.d0*mm*YB*DSIN(h/(2*f))**2 
      BRL1(5,7)=1.d0/2.d0*DBR**2*DSIN(h/(2*f))**2 
      BRL1(5,8)=(mm*YB*DCOS(h/(2*f))*DSIN(h/(2*f)))/DSQRT(2.d0) 
      BRL1(5,9)=-((DBR**2*DCOS(h/(2*f))*DSIN(h/(2*f)))/DSQRT(2.d0)) 
      BRL1(6,6)=mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRL1(6,7)=-mm*(-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)
      BRL1(6,8)=-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YB**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-
     ^     (YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRL1(6,9)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRL1(7,7)=mm**2+1.d0/2.d0*DBR**2*DSIN(h/(2.d0*f))**2 
      BRL1(7,8)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRL1(7,9)=-((DBR**2*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/
     ^     DSQRT(2.d0)) 
      BRL1(8,8)=mm**2+(-MYB-YB*DCOS(h/(2.d0*f))**2)**2+YB**2*
     ^     DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2 
      BRL1(8,9)=-mm*(-MYB-YB*DCOS(h/(2.d0*f))**2) 
      BRL1(9,9)=mm**2+DBR**2*DCOS(h/(2.d0*f))**2
c     
      DO i=1,9
         DO j=1,9
            BRL1(j,i)=BRL1(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRR1(i,j)=0.d0
         ENDDO
      ENDDO
c	
      BRR1(1,1)=DBR**2*DCOS(h/(2.d0*f))**2+DBR**2*DSIN(h/(2.d0*f))**2 
      BRR1(1,2)= 0.d0 
      BRR1(1,3)= 0.d0 
      BRR1(1,4)= 0.d0 
      BRR1(1,5)=(mm*DBR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(1,6)= 0.d0 
      BRR1(1,7)=(mm*DBR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(1,8)= 0.d0 
      BRR1(1,9)=-mm*DBR*DCOS(h/(2.d0*f)) 
      BRR1(2,2)=mm**2+DTL**2 
      BRR1(2,3)=mm*MYT 
      BRR1(2,4)=DTL*(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRR1(2,5)= 0.d0 
      BRR1(2,6)=DTL*(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRR1(2,7)= 0.d0 
      BRR1(2,8)=(DBL*DTL*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(2,9)= 0.d0 
      BRR1(3,3)=mm**2+MYT**2 
      BRR1(3,4)= 0.d0 
      BRR1(3,5)= 0.d0 
      BRR1(3,6)= 0.d0 
      BRR1(3,7)= 0.d0 
      BRR1(3,8)= 0.d0 
      BRR1(3,9)= 0.d0 
      BRR1(4,4)=mm**2+(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2 
      BRR1(4,5)=-mm*(-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2) 
      BRR1(4,6)=(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))*
     ^     (DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f))) 
      BRR1(4,7)=1.d0/2.d0*mm*YB*DSIN(h/(2.d0*f))**2 
      BRR1(4,8)=(DBL*(DBL/2.d0+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(4,9)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(5,5)=mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRR1(5,6)=1.d0/2.d0*mm*YB*DSIN(h/(2.d0*f))**2 
      BRR1(5,7)=1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2-YB*DSIN(h/(2.d0*f))**2*(-MYB-
     ^     1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2) 
      BRR1(5,8)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(5,9)=-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YB**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-
     ^     (YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRR1(6,6)=mm**2+(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))**2 
      BRR1(6,7)=-mm*(-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2) 
      BRR1(6,8)=(DBL*(-(DBL/2.d0)+1.d0/2.d0*DBL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(6,9)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(7,7)=mm**2+1.d0/2.d0*YB**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YB**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYB-1.d0/2.d0*YB*DSIN(h/(2.d0*f))**2)**2 
      BRR1(7,8)=(mm*YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR1(7,9)=-((YB*DCOS(h/(2.d0*f))*(-MYB-YB*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+
     ^(YB**2*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-
     ^     (YB*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYB-1.d0/2.d0*YB*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.d0) 
      BRR1(8,8)=mm**2+1.d0/2.d0*DBL**2*DSIN(h/(2.d0*f))**2 
      BRR1(8,9)=-mm*(-MYB-YB*DCOS(h/(2.d0*f))**2) 
      BRR1(9,9)=mm**2+(-MYB-YB*DCOS(h/(2.d0*f))**2)**2+YB**2*
     ^     DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2
c     
      DO i=1,9
         DO j=1,9
            BRR1(j,i)=BRR1(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRL2(i,j)=0.d0
         ENDDO
      ENDDO
c	
      BRL2(1,1) = DBL**2+(-(DTL/2.d0)+1.d0/2.d0*DTL*
     ^     DCOS(h/(2.d0*f)))**2+(DTL/2.d0+1.d0/2.d0*
     ^     DTL*DCOS(h/(2.d0*f)))**2+1.d0/2.d0*DTL**2*DSIN(h/(2.d0*f))**2 
      BRL2(1,2) = -mm*(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRL2(1,3) = 0.d0 
      BRL2(1,4) = -mm*(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRL2(1,5) = 0.d0 
      BRL2(1,6) = -((mm*DTL*DSIN(h/(2.d0*f)))/DSQRT(2.D0)) 
      BRL2(1,7) = 0.d0 
      BRL2(1,8) = -mm*DBL 
      BRL2(1,9) = 0.d0 
      BRL2(2,2) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRL2(2,3) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRL2(2,4) = 1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2-YT*DSIN(h/(2.d0*f))**2*
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRL2(2,5) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRL2(2,6) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.D0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.D0))-
     ^     (YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.D0) 
      BRL2(2,7) =  (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(2,8) = 0.d0 
      BRL2(2,9) = 0.d0 
      BRL2(3,3) = mm**2+1.d0/2.d0*DTR**2*DSIN(h/(2.d0*f))**2 
      BRL2(3,4) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRL2(3,5) = 1.d0/2.d0*DTR**2*DSIN(h/(2.d0*f))**2 
      BRL2(3,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(3,7) = -((DTR**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.D0)) 
      BRL2(3,8) = 0.d0 
      BRL2(3,9) = 0.d0 
      BRL2(4,4) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRL2(4,5) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRL2(4,6) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.D0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.D0))-
     ^     (YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*
     ^     DSIN(h/(2.d0*f))**2))/DSQRT(2.D0) 
      BRL2(4,7) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(4,8) = 0.d0 
      BRL2(4,9) = 0.d0 
      BRL2(5,5) = mm**2+1.d0/2.d0*DTR**2*DSIN(h/(2.d0*f))**2 
      BRL2(5,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.D0) 
      BRL2(5,7) = -((DTR**2*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/
     ^     DSQRT(2.D0)) 
      BRL2(5,8) = 0.d0 
      BRL2(5,9) = 0.d0 
      BRL2(6,6) = mm**2+(-MYT-YT*DCOS(h/(2.d0*f))**2)**2+
     ^     YT**2*DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2 
      BRL2(6,7) = -mm*(-MYT-YT*DCOS(h/(2.d0*f))**2) 
      BRL2(6,8) = 0.d0 
      BRL2(6,9) = 0.d0 
      BRL2(7,7) = mm**2+DTR**2*DCOS(h/(2.d0*f))**2 
      BRL2(7,8) = 0.d0 
      BRL2(7,9) = 0.d0 
      BRL2(8,8) = mm**2+MYB**2 
      BRL2(8,9) = mm*MYB 
      BRL2(9,9) = mm**2
c     
      DO i=1,9
         DO j=1,9
            BRL2(j,i)=BRL2(i,j)
         ENDDO
      ENDDO
c
c
c
      DO i=1,9
         DO j=1,9
            BRR2(i,j)=0.d0
         ENDDO
      ENDDO
c	
      BRR2(1,1) = DTR**2*DCOS(h/(2.d0*f))**2+DTR**2*DSIN(h/(2.d0*f))**2 
      BRR2(1,2) = 0.d0 
      BRR2(1,3) = (mm*DTR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(1,4) = 0.d0 
      BRR2(1,5) = (mm*DTR*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(1,6) = 0.d0 
      BRR2(1,7) = -mm*DTR*DCOS(h/(2.d0*f)) 
      BRR2(1,8) = 0.d0 
      BRR2(1,9) = 0.d0 
      BRR2(2,2) = mm**2+(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))**2 
      BRR2(2,3) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRR2(2,4) = (-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))*
     ^     (DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRR2(2,5) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRR2(2,6) = (DTL*(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(2,7) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(2,8) = DBL*(-(DTL/2.d0)+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRR2(2,9) = 0.d0
      BRR2(3,3) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRR2(3,4) = 1.d0/2.d0*mm*YT*DSIN(h/(2.d0*f))**2 
      BRR2(3,5) = 1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2-YT*DSIN(h/(2.d0*f))**2*
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRR2(3,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(3,7) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-(YT*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2))/
     ^     DSQRT(2.d0) 
      BRR2(3,8) = 0.d0 
      BRR2(3,9) = 0.d0 
      BRR2(4,4) = mm**2+(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))**2 
      BRR2(4,5) = -mm*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2) 
      BRR2(4,6) = (DTL*(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f)))*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(4,7) =(mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(4,8) = DBL*(DTL/2.d0+1.d0/2.d0*DTL*DCOS(h/(2.d0*f))) 
      BRR2(4,9) = 0.d0 
      BRR2(5,5) = mm**2+1.d0/2.d0*YT**2*DCOS(h/(2.d0*f))**2*
     ^     DSIN(h/(2.d0*f))**2+1.d0/4.d0*YT**2*DSIN(h/(2.d0*f))**4+
     ^     (-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2)**2 
      BRR2(5,6) = (mm*YT*DCOS(h/(2.d0*f))*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(5,7) = -((YT*DCOS(h/(2.d0*f))*(-MYT-YT*DCOS(h/(2.d0*f))**2)*
     ^     DSIN(h/(2.d0*f)))/DSQRT(2.d0))+(YT**2*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))**3)/(2.d0*DSQRT(2.d0))-(YT*DCOS(h/(2.d0*f))*
     ^     DSIN(h/(2.d0*f))*(-MYT-1.d0/2.d0*YT*DSIN(h/(2.d0*f))**2))/
     ^     DSQRT(2.d0) 
      BRR2(5,8) = 0.d0 
      BRR2(5,9) = 0.d0 
      BRR2(6,6)= mm**2+1.d0/2.d0*DTL**2*DSIN(h/(2.d0*f))**2 
      BRR2(6,7) = -mm*(-MYT-YT*DCOS(h/(2.d0*f))**2) 
      BRR2(6,8) =(DBL*DTL*DSIN(h/(2.d0*f)))/DSQRT(2.d0) 
      BRR2(6,9)= 0.d0 
      BRR2(7,7) = mm**2+(-MYT-YT*DCOS(h/(2.d0*f))**2)**2+YT**2*
     ^     DCOS(h/(2.d0*f))**2*DSIN(h/(2.d0*f))**2 
      BRR2(7,8)= 0.d0 
      BRR2(7,9)= 0.d0 
      BRR2(8,8)=mm**2+DBL**2 
      BRR2(8,9)=mm*MYB 
      BRR2(9,9)=mm**2+MYB**2
c     
      DO i=1,9
         DO j=1,9
            BRR2(j,i)=BRR2(i,j)
         ENDDO
      ENDDO


      END

c     #####################################
c     #####                           #####
c     #####  B arrow map              #####
C     #####  To be filled by Daniele  #####
C     #####################################

      SUBROUTINE barrow2(B,RN,RC,RL1,RR1,RL2,RR2,GGG,FFF)
      INTEGER i,j,k
      DOUBLE PRECISION RN(6,6), RC(4,4), RL1(9,9), RR1(9,9),
     ^     RL2(9,9), RR2(9,9), B(28803)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2
c
      Sqrt2=dsqrt(2.d0)
c
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      do i=1,28803
         B(i)=0.d0
      enddo
c
      c=dcos(h/(2.d0*f))
      s=dsin(h/(2.d0*f))
c
      B(3)=2.d0*DBR*RL1(1,9)*RR1(1,1)*s + 
     ^     DBL*RL1(1,1)*RR1(1,4)*s + 
     ^     DBL*RL1(1,1)*RR1(1,6)*s + 
     ^     c*DBR*RL1(1,5)*RR1(1,1)*Sqrt2 + 
     ^     c*DBR*RL1(1,7)*RR1(1,1)*Sqrt2 - 
     ^     c*DBL*RL1(1,1)*RR1(1,8)*Sqrt2 + 
     ^     2.d0*c*RL1(1,4)*RR1(1,5)*s*YB + 
     ^     2.d0*c*RL1(1,6)*RR1(1,5)*s*YB + 
     ^     2.d0*c*RL1(1,4)*RR1(1,7)*s*YB + 
     ^     2.d0*c*RL1(1,6)*RR1(1,7)*s*YB - 
     ^     4.d0*c*RL1(1,8)*RR1(1,9)*s*YB + 
     ^     c**2*RL1(1,8)*RR1(1,5)*Sqrt2*YB + 
     ^     c**2*RL1(1,8)*RR1(1,7)*Sqrt2*YB + 
     ^     c**2*RL1(1,4)*RR1(1,9)*Sqrt2*YB + 
     ^     c**2*RL1(1,6)*RR1(1,9)*Sqrt2*YB - 
     ^     RL1(1,8)*RR1(1,5)*s**2*Sqrt2*YB - 
     ^     RL1(1,8)*RR1(1,7)*s**2*Sqrt2*YB - 
     ^     RL1(1,4)*RR1(1,9)*s**2*Sqrt2*YB - 
     ^     RL1(1,6)*RR1(1,9)*s**2*Sqrt2*YB
      B(1183)=2.d0*DBR*RL1(2,9)*RR1(2,1)*s + 
     ^     DBL*RL1(2,1)*RR1(2,4)*s + 
     ^     DBL*RL1(2,1)*RR1(2,6)*s + 
     ^     c*DBR*RL1(2,5)*RR1(2,1)*Sqrt2 + 
     ^     c*DBR*RL1(2,7)*RR1(2,1)*Sqrt2 - 
     ^     c*DBL*RL1(2,1)*RR1(2,8)*Sqrt2 + 
     ^     2.d0*c*RL1(2,4)*RR1(2,5)*s*YB + 
     ^     2.d0*c*RL1(2,6)*RR1(2,5)*s*YB + 
     ^     2.d0*c*RL1(2,4)*RR1(2,7)*s*YB + 
     ^     2.d0*c*RL1(2,6)*RR1(2,7)*s*YB - 
     ^     4.d0*c*RL1(2,8)*RR1(2,9)*s*YB + 
     ^     c**2*RL1(2,8)*RR1(2,5)*Sqrt2*YB + 
     ^     c**2*RL1(2,8)*RR1(2,7)*Sqrt2*YB + 
     ^     c**2*RL1(2,4)*RR1(2,9)*Sqrt2*YB + 
     ^     c**2*RL1(2,6)*RR1(2,9)*Sqrt2*YB - 
     ^     RL1(2,8)*RR1(2,5)*s**2*Sqrt2*YB - 
     ^     RL1(2,8)*RR1(2,7)*s**2*Sqrt2*YB - 
     ^     RL1(2,4)*RR1(2,9)*s**2*Sqrt2*YB - 
     ^     RL1(2,6)*RR1(2,9)*s**2*Sqrt2*YB
      B(2355)=2.d0*DBR*RL1(3,9)*RR1(3,1)*s + 
     ^     DBL*RL1(3,1)*RR1(3,4)*s + 
     ^     DBL*RL1(3,1)*RR1(3,6)*s + 
     ^     c*DBR*RL1(3,5)*RR1(3,1)*Sqrt2 + 
     ^     c*DBR*RL1(3,7)*RR1(3,1)*Sqrt2 - 
     ^     c*DBL*RL1(3,1)*RR1(3,8)*Sqrt2 + 
     ^     2.d0*c*RL1(3,4)*RR1(3,5)*s*YB + 
     ^     2.d0*c*RL1(3,6)*RR1(3,5)*s*YB + 
     ^     2.d0*c*RL1(3,4)*RR1(3,7)*s*YB + 
     ^     2.d0*c*RL1(3,6)*RR1(3,7)*s*YB - 
     ^     4.d0*c*RL1(3,8)*RR1(3,9)*s*YB + 
     ^     c**2*RL1(3,8)*RR1(3,5)*Sqrt2*YB + 
     ^     c**2*RL1(3,8)*RR1(3,7)*Sqrt2*YB + 
     ^     c**2*RL1(3,4)*RR1(3,9)*Sqrt2*YB + 
     ^     c**2*RL1(3,6)*RR1(3,9)*Sqrt2*YB - 
     ^     RL1(3,8)*RR1(3,5)*s**2*Sqrt2*YB - 
     ^     RL1(3,8)*RR1(3,7)*s**2*Sqrt2*YB - 
     ^     RL1(3,4)*RR1(3,9)*s**2*Sqrt2*YB - 
     ^     RL1(3,6)*RR1(3,9)*s**2*Sqrt2*YB
      B(3519)=2.d0*DBR*RL1(4,9)*RR1(4,1)*s + 
     ^     DBL*RL1(4,1)*RR1(4,4)*s + 
     ^     DBL*RL1(4,1)*RR1(4,6)*s + 
     ^     c*DBR*RL1(4,5)*RR1(4,1)*Sqrt2 + 
     ^     c*DBR*RL1(4,7)*RR1(4,1)*Sqrt2 - 
     ^     c*DBL*RL1(4,1)*RR1(4,8)*Sqrt2 + 
     ^     2.d0*c*RL1(4,4)*RR1(4,5)*s*YB + 
     ^     2.d0*c*RL1(4,6)*RR1(4,5)*s*YB + 
     ^     2.d0*c*RL1(4,4)*RR1(4,7)*s*YB + 
     ^     2.d0*c*RL1(4,6)*RR1(4,7)*s*YB - 
     ^     4.d0*c*RL1(4,8)*RR1(4,9)*s*YB + 
     ^     c**2*RL1(4,8)*RR1(4,5)*Sqrt2*YB + 
     ^     c**2*RL1(4,8)*RR1(4,7)*Sqrt2*YB + 
     ^     c**2*RL1(4,4)*RR1(4,9)*Sqrt2*YB + 
     ^     c**2*RL1(4,6)*RR1(4,9)*Sqrt2*YB - 
     ^     RL1(4,8)*RR1(4,5)*s**2*Sqrt2*YB - 
     ^     RL1(4,8)*RR1(4,7)*s**2*Sqrt2*YB - 
     ^     RL1(4,4)*RR1(4,9)*s**2*Sqrt2*YB - 
     ^     RL1(4,6)*RR1(4,9)*s**2*Sqrt2*YB
      B(4675)=2.d0*DBR*RL1(5,9)*RR1(5,1)*s + 
     ^     DBL*RL1(5,1)*RR1(5,4)*s + 
     ^     DBL*RL1(5,1)*RR1(5,6)*s + 
     ^     c*DBR*RL1(5,5)*RR1(5,1)*Sqrt2 + 
     ^     c*DBR*RL1(5,7)*RR1(5,1)*Sqrt2 - 
     ^     c*DBL*RL1(5,1)*RR1(5,8)*Sqrt2 + 
     ^     2.d0*c*RL1(5,4)*RR1(5,5)*s*YB + 
     ^     2.d0*c*RL1(5,6)*RR1(5,5)*s*YB + 
     ^     2.d0*c*RL1(5,4)*RR1(5,7)*s*YB + 
     ^     2.d0*c*RL1(5,6)*RR1(5,7)*s*YB - 
     ^     4.d0*c*RL1(5,8)*RR1(5,9)*s*YB + 
     ^     c**2*RL1(5,8)*RR1(5,5)*Sqrt2*YB + 
     ^     c**2*RL1(5,8)*RR1(5,7)*Sqrt2*YB + 
     ^     c**2*RL1(5,4)*RR1(5,9)*Sqrt2*YB + 
     ^     c**2*RL1(5,6)*RR1(5,9)*Sqrt2*YB - 
     ^     RL1(5,8)*RR1(5,5)*s**2*Sqrt2*YB - 
     ^     RL1(5,8)*RR1(5,7)*s**2*Sqrt2*YB - 
     ^     RL1(5,4)*RR1(5,9)*s**2*Sqrt2*YB - 
     ^     RL1(5,6)*RR1(5,9)*s**2*Sqrt2*YB
      B(5823)=2.d0*DBR*RL1(6,9)*RR1(6,1)*s + 
     ^     DBL*RL1(6,1)*RR1(6,4)*s + 
     ^     DBL*RL1(6,1)*RR1(6,6)*s + 
     ^     c*DBR*RL1(6,5)*RR1(6,1)*Sqrt2 + 
     ^     c*DBR*RL1(6,7)*RR1(6,1)*Sqrt2 - 
     ^     c*DBL*RL1(6,1)*RR1(6,8)*Sqrt2 + 
     ^     2.d0*c*RL1(6,4)*RR1(6,5)*s*YB + 
     ^     2.d0*c*RL1(6,6)*RR1(6,5)*s*YB + 
     ^     2.d0*c*RL1(6,4)*RR1(6,7)*s*YB + 
     ^     2.d0*c*RL1(6,6)*RR1(6,7)*s*YB - 
     ^     4.d0*c*RL1(6,8)*RR1(6,9)*s*YB + 
     ^     c**2*RL1(6,8)*RR1(6,5)*Sqrt2*YB + 
     ^     c**2*RL1(6,8)*RR1(6,7)*Sqrt2*YB + 
     ^     c**2*RL1(6,4)*RR1(6,9)*Sqrt2*YB + 
     ^     c**2*RL1(6,6)*RR1(6,9)*Sqrt2*YB - 
     ^     RL1(6,8)*RR1(6,5)*s**2*Sqrt2*YB - 
     ^     RL1(6,8)*RR1(6,7)*s**2*Sqrt2*YB - 
     ^     RL1(6,4)*RR1(6,9)*s**2*Sqrt2*YB - 
     ^     RL1(6,6)*RR1(6,9)*s**2*Sqrt2*YB
      B(6963)=2.d0*DBR*RL1(7,9)*RR1(7,1)*s + 
     ^     DBL*RL1(7,1)*RR1(7,4)*s + 
     ^     DBL*RL1(7,1)*RR1(7,6)*s + 
     ^     c*DBR*RL1(7,5)*RR1(7,1)*Sqrt2 + 
     ^     c*DBR*RL1(7,7)*RR1(7,1)*Sqrt2 - 
     ^     c*DBL*RL1(7,1)*RR1(7,8)*Sqrt2 + 
     ^     2.d0*c*RL1(7,4)*RR1(7,5)*s*YB + 
     ^     2.d0*c*RL1(7,6)*RR1(7,5)*s*YB + 
     ^     2.d0*c*RL1(7,4)*RR1(7,7)*s*YB + 
     ^     2.d0*c*RL1(7,6)*RR1(7,7)*s*YB - 
     ^     4.d0*c*RL1(7,8)*RR1(7,9)*s*YB + 
     ^     c**2*RL1(7,8)*RR1(7,5)*Sqrt2*YB + 
     ^     c**2*RL1(7,8)*RR1(7,7)*Sqrt2*YB + 
     ^     c**2*RL1(7,4)*RR1(7,9)*Sqrt2*YB + 
     ^     c**2*RL1(7,6)*RR1(7,9)*Sqrt2*YB - 
     ^     RL1(7,8)*RR1(7,5)*s**2*Sqrt2*YB - 
     ^     RL1(7,8)*RR1(7,7)*s**2*Sqrt2*YB - 
     ^     RL1(7,4)*RR1(7,9)*s**2*Sqrt2*YB - 
     ^     RL1(7,6)*RR1(7,9)*s**2*Sqrt2*YB
      B(8095)=2.d0*DBR*RL1(8,9)*RR1(8,1)*s + 
     ^     DBL*RL1(8,1)*RR1(8,4)*s + 
     ^     DBL*RL1(8,1)*RR1(8,6)*s + 
     ^     c*DBR*RL1(8,5)*RR1(8,1)*Sqrt2 + 
     ^     c*DBR*RL1(8,7)*RR1(8,1)*Sqrt2 - 
     ^     c*DBL*RL1(8,1)*RR1(8,8)*Sqrt2 + 
     ^     2.d0*c*RL1(8,4)*RR1(8,5)*s*YB + 
     ^     2.d0*c*RL1(8,6)*RR1(8,5)*s*YB + 
     ^     2.d0*c*RL1(8,4)*RR1(8,7)*s*YB + 
     ^     2.d0*c*RL1(8,6)*RR1(8,7)*s*YB - 
     ^     4.d0*c*RL1(8,8)*RR1(8,9)*s*YB + 
     ^     c**2*RL1(8,8)*RR1(8,5)*Sqrt2*YB + 
     ^     c**2*RL1(8,8)*RR1(8,7)*Sqrt2*YB + 
     ^     c**2*RL1(8,4)*RR1(8,9)*Sqrt2*YB + 
     ^     c**2*RL1(8,6)*RR1(8,9)*Sqrt2*YB - 
     ^     RL1(8,8)*RR1(8,5)*s**2*Sqrt2*YB - 
     ^     RL1(8,8)*RR1(8,7)*s**2*Sqrt2*YB - 
     ^     RL1(8,4)*RR1(8,9)*s**2*Sqrt2*YB - 
     ^     RL1(8,6)*RR1(8,9)*s**2*Sqrt2*YB
      B(9219)=2.d0*DBR*RL1(9,9)*RR1(9,1)*s + 
     ^     DBL*RL1(9,1)*RR1(9,4)*s + 
     ^     DBL*RL1(9,1)*RR1(9,6)*s + 
     ^     c*DBR*RL1(9,5)*RR1(9,1)*Sqrt2 + 
     ^     c*DBR*RL1(9,7)*RR1(9,1)*Sqrt2 - 
     ^     c*DBL*RL1(9,1)*RR1(9,8)*Sqrt2 + 
     ^     2.d0*c*RL1(9,4)*RR1(9,5)*s*YB + 
     ^     2.d0*c*RL1(9,6)*RR1(9,5)*s*YB + 
     ^     2.d0*c*RL1(9,4)*RR1(9,7)*s*YB + 
     ^     2.d0*c*RL1(9,6)*RR1(9,7)*s*YB - 
     ^     4.d0*c*RL1(9,8)*RR1(9,9)*s*YB + 
     ^     c**2*RL1(9,8)*RR1(9,5)*Sqrt2*YB + 
     ^     c**2*RL1(9,8)*RR1(9,7)*Sqrt2*YB + 
     ^     c**2*RL1(9,4)*RR1(9,9)*Sqrt2*YB + 
     ^     c**2*RL1(9,6)*RR1(9,9)*Sqrt2*YB - 
     ^     RL1(9,8)*RR1(9,5)*s**2*Sqrt2*YB - 
     ^     RL1(9,8)*RR1(9,7)*s**2*Sqrt2*YB - 
     ^     RL1(9,4)*RR1(9,9)*s**2*Sqrt2*YB - 
     ^     RL1(9,6)*RR1(9,9)*s**2*Sqrt2*YB
c
      B(9)=6.d0*g0*RL1(1,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(1,1)**2*RN(1,2) + 
     ^     6.d0*g*RL1(1,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(1,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(1,4)**2*RN(1,3) + 
     ^     6.d0*g*RL1(1,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(1,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(1,7)**2*RN(1,3) + 
     ^     12.d0*g*RL1(1,4)*RL1(1,8)*RN(1,5) - 
     ^     12.d0*g*RL1(1,6)*RL1(1,8)*RN(1,5) + 
     ^     12.d0*g*RL1(1,5)*RL1(1,9)*RN(1,5) - 
     ^     12.d0*g*RL1(1,7)*RL1(1,9)*RN(1,5) - 
     ^     g*RL1(1,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(1,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(1,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(1,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(1,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(1,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(1,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(1,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(1,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(1,3)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(1,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(1,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(1,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(1,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(1,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(1,9)**2*RN(1,6)*Sqrt2
      B(1189)=6.d0*g0*RL1(2,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(2,1)**2*RN(1,2) + 
     ^     6.d0*g*RL1(2,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(2,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(2,4)**2*RN(1,3) + 
     ^     6.d0*g*RL1(2,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(2,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(2,7)**2*RN(1,3) + 
     ^     12.d0*g*RL1(2,4)*RL1(2,8)*RN(1,5) - 
     ^     12.d0*g*RL1(2,6)*RL1(2,8)*RN(1,5) + 
     ^     12.d0*g*RL1(2,5)*RL1(2,9)*RN(1,5) - 
     ^     12.d0*g*RL1(2,7)*RL1(2,9)*RN(1,5) - 
     ^     g*RL1(2,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(2,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(2,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(2,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(2,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(2,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(2,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(2,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(2,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(2,3)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(2,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(2,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(2,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(2,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(2,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(2,9)**2*RN(1,6)*Sqrt2
      B(2361)=6.d0*g0*RL1(3,1)**2*RN(1,1) - 
     ^     2*g0y*RL1(3,1)**2*RN(1,2) +
     ^     6.d0*g*RL1(3,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(3,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(3,4)**2*RN(1,3) + 
     ^     6.d0*g*RL1(3,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(3,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(3,7)**2*RN(1,3) +
     ^     12.d0*g*RL1(3,4)*RL1(3,8)*RN(1,5) - 
     ^     12.d0*g*RL1(3,6)*RL1(3,8)*RN(1,5) + 
     ^     12.d0*g*RL1(3,5)*RL1(3,9)*RN(1,5) - 
     ^     12.d0*g*RL1(3,7)*RL1(3,9)*RN(1,5) - 
     ^     g*RL1(3,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(3,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(3,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(3,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(3,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(3,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(3,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(3,9)**2*RN(1,4)*Sqrt2 +
     ^     7.d0*g*RL1(3,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(3,3)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(3,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(3,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(3,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(3,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(3,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(3,9)**2*RN(1,6)*Sqrt2
      B(3525)=6.d0*g0*RL1(4,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(4,1)**2*RN(1,2) +
     ^     6.d0*g*RL1(4,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(4,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(4,4)**2*RN(1,3) +
     ^     6.d0*g*RL1(4,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(4,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(4,7)**2*RN(1,3) +
     ^     12.d0*g*RL1(4,4)*RL1(4,8)*RN(1,5) - 
     ^     12.d0*g*RL1(4,6)*RL1(4,8)*RN(1,5) + 
     ^     12.d0*g*RL1(4,5)*RL1(4,9)*RN(1,5) - 
     ^     12.d0*g*RL1(4,7)*RL1(4,9)*RN(1,5) - 
     ^     g*RL1(4,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(4,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(4,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(4,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(4,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(4,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(4,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(4,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(4,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(4,3)**2*RN(1,6)*Sqrt2 -
     ^     5.d0*g*RL1(4,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(4,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(4,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(4,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(4,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(4,9)**2*RN(1,6)*Sqrt2
      B(4681)=6.d0*g0*RL1(5,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(5,1)**2*RN(1,2) + 
     ^     6.d0*g*RL1(5,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(5,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(5,4)**2*RN(1,3) + 
     ^     6.d0*g*RL1(5,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(5,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(5,7)**2*RN(1,3) + 
     ^     12.d0*g*RL1(5,4)*RL1(5,8)*RN(1,5) - 
     ^     12.d0*g*RL1(5,6)*RL1(5,8)*RN(1,5) +
     ^     12.d0*g*RL1(5,5)*RL1(5,9)*RN(1,5) - 
     ^     12.d0*g*RL1(5,7)*RL1(5,9)*RN(1,5) - 
     ^     g*RL1(5,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(5,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(5,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(5,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(5,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(5,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(5,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(5,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(5,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(5,3)**2*RN(1,6)*Sqrt2 -
     ^     5.d0*g*RL1(5,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(5,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(5,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(5,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(5,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(5,9)**2*RN(1,6)*Sqrt2
      B(5829)=6.d0*g0*RL1(6,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(6,1)**2*RN(1,2) +
     ^     6.d0*g*RL1(6,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(6,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(6,4)**2*RN(1,3) +
     ^     6.d0*g*RL1(6,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(6,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(6,7)**2*RN(1,3) + 
     ^     12.d0*g*RL1(6,4)*RL1(6,8)*RN(1,5) - 
     ^     12.d0*g*RL1(6,6)*RL1(6,8)*RN(1,5) + 
     ^     12.d0*g*RL1(6,5)*RL1(6,9)*RN(1,5) - 
     ^     12.d0*g*RL1(6,7)*RL1(6,9)*RN(1,5) -
     ^     g*RL1(6,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(6,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(6,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(6,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(6,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(6,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(6,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(6,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(6,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(6,3)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(6,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(6,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(6,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(6,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(6,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(6,9)**2*RN(1,6)*Sqrt2
      B(6969)=6.d0*g0*RL1(7,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(7,1)**2*RN(1,2) +
     ^     6.d0*g*RL1(7,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(7,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(7,4)**2*RN(1,3) +
     ^     6.d0*g*RL1(7,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(7,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(7,7)**2*RN(1,3) +
     ^     12.d0*g*RL1(7,4)*RL1(7,8)*RN(1,5) - 
     ^     12.d0*g*RL1(7,6)*RL1(7,8)*RN(1,5) + 
     ^     12.d0*g*RL1(7,5)*RL1(7,9)*RN(1,5) - 
     ^     12.d0*g*RL1(7,7)*RL1(7,9)*RN(1,5) - 
     ^     g*RL1(7,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(7,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(7,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(7,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(7,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(7,7)**2*RN(1,4)*Sqrt2 +
     ^     2.d0*g*RL1(7,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(7,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(7,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(7,3)**2*RN(1,6)*Sqrt2 -
     ^     5.d0*g*RL1(7,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(7,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(7,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(7,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(7,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(7,9)**2*RN(1,6)*Sqrt2
      B(8101)=6.d0*g0*RL1(8,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(8,1)**2*RN(1,2) +
     ^     6.d0*g*RL1(8,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(8,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(8,4)**2*RN(1,3) + 
     ^     6.d0*g*RL1(8,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(8,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(8,7)**2*RN(1,3) + 
     ^     12.d0*g*RL1(8,4)*RL1(8,8)*RN(1,5) - 
     ^     12.d0*g*RL1(8,6)*RL1(8,8)*RN(1,5) +
     ^     12.d0*g*RL1(8,5)*RL1(8,9)*RN(1,5) - 
     ^     12.d0*g*RL1(8,7)*RL1(8,9)*RN(1,5) - 
     ^     g*RL1(8,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(8,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(8,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(8,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(8,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(8,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(8,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(8,9)**2*RN(1,4)*Sqrt2 +
     ^     7.d0*g*RL1(8,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(8,3)**2*RN(1,6)*Sqrt2 -
     ^     5.d0*g*RL1(8,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(8,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(8,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(8,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(8,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(8,9)**2*RN(1,6)*Sqrt2
      B(9225)=6.d0*g0*RL1(9,1)**2*RN(1,1) - 
     ^     2.d0*g0y*RL1(9,1)**2*RN(1,2) + 
     ^     6.d0*g*RL1(9,2)**2*RN(1,3) + 
     ^     6.d0*g*RL1(9,3)**2*RN(1,3) + 
     ^     6.d0*g*RL1(9,4)**2*RN(1,3) + 
     ^     6.d0*g*RL1(9,5)**2*RN(1,3) - 
     ^     6.d0*g*RL1(9,6)**2*RN(1,3) - 
     ^     6.d0*g*RL1(9,7)**2*RN(1,3) + 
     ^     12.d0*g*RL1(9,4)*RL1(9,8)*RN(1,5) - 
     ^     12.d0*g*RL1(9,6)*RL1(9,8)*RN(1,5) +
     ^     12.d0*g*RL1(9,5)*RL1(9,9)*RN(1,5) - 
     ^     12.d0*g*RL1(9,7)*RL1(9,9)*RN(1,5) -
     ^     g*RL1(9,2)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(9,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(9,4)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL1(9,5)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(9,6)**2*RN(1,4)*Sqrt2 + 
     ^     5.d0*g*RL1(9,7)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(9,8)**2*RN(1,4)*Sqrt2 + 
     ^     2.d0*g*RL1(9,9)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL1(9,2)**2*RN(1,6)*Sqrt2 + 
     ^     7.d0*g*RL1(9,3)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(9,4)**2*RN(1,6)*Sqrt2 - 
     ^     5.d0*g*RL1(9,5)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(9,6)**2*RN(1,6)*Sqrt2 + 
     ^     g*RL1(9,7)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(9,8)**2*RN(1,6)*Sqrt2 - 
     ^     2.d0*g*RL1(9,9)**2*RN(1,6)*Sqrt2
c
      B(10071)=2.d0*DTR*RL2(1,7)*RR2(1,1)*s + 
     ^     DTL*RL2(1,1)*RR2(1,2)*s +
     ^     DTL*RL2(1,1)*RR2(1,4)*s + 
     ^     c*DTR*RL2(1,3)*RR2(1,1)*Sqrt2 +
     ^     c*DTR*RL2(1,5)*RR2(1,1)*Sqrt2 - 
     ^     c*DTL*RL2(1,1)*RR2(1,6)*Sqrt2 +
     ^     2.d0*c*RL2(1,2)*RR2(1,3)*s*YT + 
     ^     2.d0*c*RL2(1,4)*RR2(1,3)*s*YT +
     ^     2.d0*c*RL2(1,2)*RR2(1,5)*s*YT + 
     ^     2.d0*c*RL2(1,4)*RR2(1,5)*s*YT -
     ^     4.d0*c*RL2(1,6)*RR2(1,7)*s*YT + 
     ^     c**2*RL2(1,6)*RR2(1,3)*Sqrt2*YT +
     ^     c**2*RL2(1,6)*RR2(1,5)*Sqrt2*YT + 
     ^     c**2*RL2(1,2)*RR2(1,7)*Sqrt2*YT +
     ^     c**2*RL2(1,4)*RR2(1,7)*Sqrt2*YT - 
     ^     RL2(1,6)*RR2(1,3)*s**2*Sqrt2*YT -
     ^     RL2(1,6)*RR2(1,5)*s**2*Sqrt2*YT - 
     ^     RL2(1,2)*RR2(1,7)*s**2*Sqrt2*YT -
     ^     RL2(1,4)*RR2(1,7)*s**2*Sqrt2*YT
      B(11003)=2.d0*DTR*RL2(2,7)*RR2(2,1)*s +
     ^     DTL*RL2(2,1)*RR2(2,2)*s +
     ^     DTL*RL2(2,1)*RR2(2,4)*s + 
     ^     c*DTR*RL2(2,3)*RR2(2,1)*Sqrt2 + 
     ^     c*DTR*RL2(2,5)*RR2(2,1)*Sqrt2 - 
     ^     c*DTL*RL2(2,1)*RR2(2,6)*Sqrt2 + 
     ^     2.d0*c*RL2(2,2)*RR2(2,3)*s*YT + 
     ^     2.d0*c*RL2(2,4)*RR2(2,3)*s*YT + 
     ^     2.d0*c*RL2(2,2)*RR2(2,5)*s*YT + 
     ^     2.d0*c*RL2(2,4)*RR2(2,5)*s*YT - 
     ^     4.d0*c*RL2(2,6)*RR2(2,7)*s*YT + 
     ^     c**2*RL2(2,6)*RR2(2,3)*Sqrt2*YT +
     ^     c**2*RL2(2,6)*RR2(2,5)*Sqrt2*YT + 
     ^     c**2*RL2(2,2)*RR2(2,7)*Sqrt2*YT + 
     ^     c**2*RL2(2,4)*RR2(2,7)*Sqrt2*YT - 
     ^     RL2(2,6)*RR2(2,3)*s**2*Sqrt2*YT - 
     ^     RL2(2,6)*RR2(2,5)*s**2*Sqrt2*YT - 
     ^     RL2(2,2)*RR2(2,7)*s**2*Sqrt2*YT -
     ^     RL2(2,4)*RR2(2,7)*s**2*Sqrt2*YT
      B(11927)=2.d0*DTR*RL2(3,7)*RR2(3,1)*s + 
     ^     DTL*RL2(3,1)*RR2(3,2)*s +
     ^     DTL*RL2(3,1)*RR2(3,4)*s + 
     ^     c*DTR*RL2(3,3)*RR2(3,1)*Sqrt2 + 
     ^     c*DTR*RL2(3,5)*RR2(3,1)*Sqrt2 - 
     ^     c*DTL*RL2(3,1)*RR2(3,6)*Sqrt2 + 
     ^     2.d0*c*RL2(3,2)*RR2(3,3)*s*YT + 
     ^     2.d0*c*RL2(3,4)*RR2(3,3)*s*YT + 
     ^     2.d0*c*RL2(3,2)*RR2(3,5)*s*YT + 
     ^     2.d0*c*RL2(3,4)*RR2(3,5)*s*YT - 
     ^     4.d0*c*RL2(3,6)*RR2(3,7)*s*YT + 
     ^     c**2*RL2(3,6)*RR2(3,3)*Sqrt2*YT + 
     ^     c**2*RL2(3,6)*RR2(3,5)*Sqrt2*YT + 
     ^     c**2*RL2(3,2)*RR2(3,7)*Sqrt2*YT + 
     ^     c**2*RL2(3,4)*RR2(3,7)*Sqrt2*YT - 
     ^     RL2(3,6)*RR2(3,3)*s**2*Sqrt2*YT - 
     ^     RL2(3,6)*RR2(3,5)*s**2*Sqrt2*YT - 
     ^     RL2(3,2)*RR2(3,7)*s**2*Sqrt2*YT - 
     ^     RL2(3,4)*RR2(3,7)*s**2*Sqrt2*YT
      B(12843)=2.d0*DTR*RL2(4,7)*RR2(4,1)*s + 
     ^     DTL*RL2(4,1)*RR2(4,2)*s +
     ^     DTL*RL2(4,1)*RR2(4,4)*s + 
     ^     c*DTR*RL2(4,3)*RR2(4,1)*Sqrt2 +
     ^     c*DTR*RL2(4,5)*RR2(4,1)*Sqrt2 - 
     ^     c*DTL*RL2(4,1)*RR2(4,6)*Sqrt2 + 
     ^     2.d0*c*RL2(4,2)*RR2(4,3)*s*YT + 
     ^     2.d0*c*RL2(4,4)*RR2(4,3)*s*YT + 
     ^     2.d0*c*RL2(4,2)*RR2(4,5)*s*YT + 
     ^     2.d0*c*RL2(4,4)*RR2(4,5)*s*YT - 
     ^     4.d0*c*RL2(4,6)*RR2(4,7)*s*YT + 
     ^     c**2*RL2(4,6)*RR2(4,3)*Sqrt2*YT +
     ^     c**2*RL2(4,6)*RR2(4,5)*Sqrt2*YT + 
     ^     c**2*RL2(4,2)*RR2(4,7)*Sqrt2*YT + 
     ^     c**2*RL2(4,4)*RR2(4,7)*Sqrt2*YT - 
     ^     RL2(4,6)*RR2(4,3)*s**2*Sqrt2*YT - 
     ^     RL2(4,6)*RR2(4,5)*s**2*Sqrt2*YT - 
     ^     RL2(4,2)*RR2(4,7)*s**2*Sqrt2*YT - 
     ^     RL2(4,4)*RR2(4,7)*s**2*Sqrt2*YT
      B(13751)=2.d0*DTR*RL2(5,7)*RR2(5,1)*s + 
     ^     DTL*RL2(5,1)*RR2(5,2)*s +
     ^     DTL*RL2(5,1)*RR2(5,4)*s + 
     ^     c*DTR*RL2(5,3)*RR2(5,1)*Sqrt2 + 
     ^     c*DTR*RL2(5,5)*RR2(5,1)*Sqrt2 - 
     ^     c*DTL*RL2(5,1)*RR2(5,6)*Sqrt2 + 
     ^     2.d0*c*RL2(5,2)*RR2(5,3)*s*YT + 
     ^     2.d0*c*RL2(5,4)*RR2(5,3)*s*YT + 
     ^     2.d0*c*RL2(5,2)*RR2(5,5)*s*YT + 
     ^     2.d0*c*RL2(5,4)*RR2(5,5)*s*YT - 
     ^     4.d0*c*RL2(5,6)*RR2(5,7)*s*YT + 
     ^     c**2*RL2(5,6)*RR2(5,3)*Sqrt2*YT + 
     ^     c**2*RL2(5,6)*RR2(5,5)*Sqrt2*YT + 
     ^     c**2*RL2(5,2)*RR2(5,7)*Sqrt2*YT + 
     ^     c**2*RL2(5,4)*RR2(5,7)*Sqrt2*YT - 
     ^     RL2(5,6)*RR2(5,3)*s**2*Sqrt2*YT - 
     ^     RL2(5,6)*RR2(5,5)*s**2*Sqrt2*YT - 
     ^     RL2(5,2)*RR2(5,7)*s**2*Sqrt2*YT - 
     ^     RL2(5,4)*RR2(5,7)*s**2*Sqrt2*YT
      B(14651)=2.d0*DTR*RL2(6,7)*RR2(6,1)*s + 
     ^     DTL*RL2(6,1)*RR2(6,2)*s +
     ^     DTL*RL2(6,1)*RR2(6,4)*s + 
     ^     c*DTR*RL2(6,3)*RR2(6,1)*Sqrt2 + 
     ^     c*DTR*RL2(6,5)*RR2(6,1)*Sqrt2 - 
     ^     c*DTL*RL2(6,1)*RR2(6,6)*Sqrt2 + 
     ^     2.d0*c*RL2(6,2)*RR2(6,3)*s*YT + 
     ^     2.d0*c*RL2(6,4)*RR2(6,3)*s*YT + 
     ^     2.d0*c*RL2(6,2)*RR2(6,5)*s*YT + 
     ^     2.d0*c*RL2(6,4)*RR2(6,5)*s*YT - 
     ^     4.d0*c*RL2(6,6)*RR2(6,7)*s*YT + 
     ^     c**2*RL2(6,6)*RR2(6,3)*Sqrt2*YT + 
     ^     c**2*RL2(6,6)*RR2(6,5)*Sqrt2*YT + 
     ^     c**2*RL2(6,2)*RR2(6,7)*Sqrt2*YT + 
     ^     c**2*RL2(6,4)*RR2(6,7)*Sqrt2*YT - 
     ^     RL2(6,6)*RR2(6,3)*s**2*Sqrt2*YT - 
     ^     RL2(6,6)*RR2(6,5)*s**2*Sqrt2*YT - 
     ^     RL2(6,2)*RR2(6,7)*s**2*Sqrt2*YT - 
     ^     RL2(6,4)*RR2(6,7)*s**2*Sqrt2*YT
      B(15543)=2.d0*DTR*RL2(7,7)*RR2(7,1)*s + 
     ^     DTL*RL2(7,1)*RR2(7,2)*s + 
     ^     DTL*RL2(7,1)*RR2(7,4)*s + 
     ^     c*DTR*RL2(7,3)*RR2(7,1)*Sqrt2 + 
     ^     c*DTR*RL2(7,5)*RR2(7,1)*Sqrt2 - 
     ^     c*DTL*RL2(7,1)*RR2(7,6)*Sqrt2 + 
     ^     2.d0*c*RL2(7,2)*RR2(7,3)*s*YT + 
     ^     2.d0*c*RL2(7,4)*RR2(7,3)*s*YT + 
     ^     2.d0*c*RL2(7,2)*RR2(7,5)*s*YT + 
     ^     2.d0*c*RL2(7,4)*RR2(7,5)*s*YT - 
     ^     4.d0*c*RL2(7,6)*RR2(7,7)*s*YT + 
     ^     c**2*RL2(7,6)*RR2(7,3)*Sqrt2*YT + 
     ^     c**2*RL2(7,6)*RR2(7,5)*Sqrt2*YT + 
     ^     c**2*RL2(7,2)*RR2(7,7)*Sqrt2*YT + 
     ^     c**2*RL2(7,4)*RR2(7,7)*Sqrt2*YT - 
     ^     RL2(7,6)*RR2(7,3)*s**2*Sqrt2*YT - 
     ^     RL2(7,6)*RR2(7,5)*s**2*Sqrt2*YT - 
     ^     RL2(7,2)*RR2(7,7)*s**2*Sqrt2*YT - 
     ^     RL2(7,4)*RR2(7,7)*s**2*Sqrt2*YT
      B(16427)=2.d0*DTR*RL2(8,7)*RR2(8,1)*s + 
     ^     DTL*RL2(8,1)*RR2(8,2)*s + 
     ^     DTL*RL2(8,1)*RR2(8,4)*s + 
     ^     c*DTR*RL2(8,3)*RR2(8,1)*Sqrt2 + 
     ^     c*DTR*RL2(8,5)*RR2(8,1)*Sqrt2 - 
     ^     c*DTL*RL2(8,1)*RR2(8,6)*Sqrt2 + 
     ^     2.d0*c*RL2(8,2)*RR2(8,3)*s*YT + 
     ^     2.d0*c*RL2(8,4)*RR2(8,3)*s*YT + 
     ^     2.d0*c*RL2(8,2)*RR2(8,5)*s*YT + 
     ^     2.d0*c*RL2(8,4)*RR2(8,5)*s*YT - 
     ^     4.d0*c*RL2(8,6)*RR2(8,7)*s*YT + 
     ^     c**2*RL2(8,6)*RR2(8,3)*Sqrt2*YT + 
     ^     c**2*RL2(8,6)*RR2(8,5)*Sqrt2*YT + 
     ^     c**2*RL2(8,2)*RR2(8,7)*Sqrt2*YT + 
     ^     c**2*RL2(8,4)*RR2(8,7)*Sqrt2*YT - 
     ^     RL2(8,6)*RR2(8,3)*s**2*Sqrt2*YT - 
     ^     RL2(8,6)*RR2(8,5)*s**2*Sqrt2*YT - 
     ^     RL2(8,2)*RR2(8,7)*s**2*Sqrt2*YT - 
     ^     RL2(8,4)*RR2(8,7)*s**2*Sqrt2*YT
      B(17303)=2.d0*DTR*RL2(9,7)*RR2(9,1)*s + 
     ^     DTL*RL2(9,1)*RR2(9,2)*s + 
     ^     DTL*RL2(9,1)*RR2(9,4)*s + 
     ^     c*DTR*RL2(9,3)*RR2(9,1)*Sqrt2 + 
     ^     c*DTR*RL2(9,5)*RR2(9,1)*Sqrt2 - 
     ^     c*DTL*RL2(9,1)*RR2(9,6)*Sqrt2 + 
     ^     2.d0*c*RL2(9,2)*RR2(9,3)*s*YT + 
     ^     2.d0*c*RL2(9,4)*RR2(9,3)*s*YT + 
     ^     2.d0*c*RL2(9,2)*RR2(9,5)*s*YT + 
     ^     2.d0*c*RL2(9,4)*RR2(9,5)*s*YT - 
     ^     4.d0*c*RL2(9,6)*RR2(9,7)*s*YT + 
     ^     c**2*RL2(9,6)*RR2(9,3)*Sqrt2*YT + 
     ^     c**2*RL2(9,6)*RR2(9,5)*Sqrt2*YT + 
     ^     c**2*RL2(9,2)*RR2(9,7)*Sqrt2*YT + 
     ^     c**2*RL2(9,4)*RR2(9,7)*Sqrt2*YT - 
     ^     RL2(9,6)*RR2(9,3)*s**2*Sqrt2*YT - 
     ^     RL2(9,6)*RR2(9,5)*s**2*Sqrt2*YT - 
     ^     RL2(9,2)*RR2(9,7)*s**2*Sqrt2*YT - 
     ^     RL2(9,4)*RR2(9,7)*s**2*Sqrt2*YT
c
      B(10077)=6.d0*g0*RL2(1,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(1,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(1,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(1,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(1,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(1,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(1,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(1,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(1,2)*RL2(1,6)*RN(1,5) + 
     ^     12.d0*g*RL2(1,4)*RL2(1,6)*RN(1,5) - 
     ^     12.d0*g*RL2(1,3)*RL2(1,7)*RN(1,5) + 
     ^     12.d0*g*RL2(1,5)*RL2(1,7)*RN(1,5) + 
     ^     7.d0*g*RL2(1,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(1,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(1,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(1,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(1,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(1,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(1,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(1,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(1,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(1,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(1,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(1,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(1,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(1,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(1,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(1,9)**2*RN(1,6)*Sqrt2
      B(11009)=6.d0*g0*RL2(2,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(2,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(2,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(2,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(2,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(2,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(2,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(2,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(2,2)*RL2(2,6)*RN(1,5) + 
     ^     12.d0*g*RL2(2,4)*RL2(2,6)*RN(1,5) - 
     ^     12.d0*g*RL2(2,3)*RL2(2,7)*RN(1,5) + 
     ^     12.d0*g*RL2(2,5)*RL2(2,7)*RN(1,5) + 
     ^     7.d0*g*RL2(2,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(2,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(2,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(2,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(2,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(2,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(2,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(2,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(2,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(2,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(2,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(2,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(2,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(2,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(2,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(2,9)**2*RN(1,6)*Sqrt2
      B(11933)=6.d0*g0*RL2(3,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(3,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(3,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(3,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(3,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(3,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(3,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(3,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(3,2)*RL2(3,6)*RN(1,5) + 
     ^     12.d0*g*RL2(3,4)*RL2(3,6)*RN(1,5) - 
     ^     12.d0*g*RL2(3,3)*RL2(3,7)*RN(1,5) + 
     ^     12.d0*g*RL2(3,5)*RL2(3,7)*RN(1,5) + 
     ^     7.d0*g*RL2(3,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(3,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(3,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(3,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(3,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(3,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(3,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(3,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(3,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(3,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(3,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(3,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(3,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(3,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(3,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(3,9)**2*RN(1,6)*Sqrt2
      B(12849)=6.d0*g0*RL2(4,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(4,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(4,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(4,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(4,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(4,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(4,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(4,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(4,2)*RL2(4,6)*RN(1,5) + 
     ^     12.d0*g*RL2(4,4)*RL2(4,6)*RN(1,5) - 
     ^     12.d0*g*RL2(4,3)*RL2(4,7)*RN(1,5) + 
     ^     12.d0*g*RL2(4,5)*RL2(4,7)*RN(1,5) + 
     ^     7.d0*g*RL2(4,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(4,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(4,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(4,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(4,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(4,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(4,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(4,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(4,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(4,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(4,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(4,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(4,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(4,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(4,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(4,9)**2*RN(1,6)*Sqrt2
      B(13757)=6.d0*g0*RL2(5,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(5,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(5,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(5,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(5,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(5,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(5,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(5,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(5,2)*RL2(5,6)*RN(1,5) + 
     ^     12.d0*g*RL2(5,4)*RL2(5,6)*RN(1,5) - 
     ^     12.d0*g*RL2(5,3)*RL2(5,7)*RN(1,5) + 
     ^     12.d0*g*RL2(5,5)*RL2(5,7)*RN(1,5) + 
     ^     7.d0*g*RL2(5,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(5,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(5,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(5,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(5,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(5,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(5,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(5,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(5,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(5,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(5,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(5,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(5,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(5,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(5,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(5,9)**2*RN(1,6)*Sqrt2
      B(14657)=6.d0*g0*RL2(6,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(6,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(6,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(6,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(6,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(6,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(6,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(6,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(6,2)*RL2(6,6)*RN(1,5) + 
     ^     12.d0*g*RL2(6,4)*RL2(6,6)*RN(1,5) - 
     ^     12.d0*g*RL2(6,3)*RL2(6,7)*RN(1,5) + 
     ^     12.d0*g*RL2(6,5)*RL2(6,7)*RN(1,5) + 
     ^     7.d0*g*RL2(6,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(6,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(6,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(6,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(6,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(6,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(6,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(6,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(6,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(6,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(6,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(6,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(6,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(6,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(6,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(6,9)**2*RN(1,6)*Sqrt2
      B(15549)=6.d0*g0*RL2(7,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(7,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(7,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(7,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(7,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(7,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(7,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(7,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(7,2)*RL2(7,6)*RN(1,5) + 
     ^     12.d0*g*RL2(7,4)*RL2(7,6)*RN(1,5) - 
     ^     12.d0*g*RL2(7,3)*RL2(7,7)*RN(1,5) + 
     ^     12.d0*g*RL2(7,5)*RL2(7,7)*RN(1,5) + 
     ^     7.d0*g*RL2(7,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(7,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(7,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(7,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(7,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(7,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(7,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(7,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(7,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(7,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(7,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(7,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(7,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(7,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(7,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(7,9)**2*RN(1,6)*Sqrt2
      B(16433)=6.d0*g0*RL2(8,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(8,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(8,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(8,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(8,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(8,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(8,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(8,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(8,2)*RL2(8,6)*RN(1,5) + 
     ^     12.d0*g*RL2(8,4)*RL2(8,6)*RN(1,5) - 
     ^     12.d0*g*RL2(8,3)*RL2(8,7)*RN(1,5) + 
     ^     12.d0*g*RL2(8,5)*RL2(8,7)*RN(1,5) + 
     ^     7.d0*g*RL2(8,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(8,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(8,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(8,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(8,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(8,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(8,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(8,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(8,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(8,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(8,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(8,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(8,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(8,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(8,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(8,9)**2*RN(1,6)*Sqrt2
      B(17309)=6.d0*g0*RL2(9,1)**2*RN(1,1) + 
     ^     2.d0*g0y*RL2(9,1)**2*RN(1,2) - 
     ^     6.d0*g*RL2(9,2)**2*RN(1,3) - 
     ^     6.d0*g*RL2(9,3)**2*RN(1,3) + 
     ^     6.d0*g*RL2(9,4)**2*RN(1,3) + 
     ^     6.d0*g*RL2(9,5)**2*RN(1,3) + 
     ^     6.d0*g*RL2(9,8)**2*RN(1,3) + 
     ^     6.d0*g*RL2(9,9)**2*RN(1,3) - 
     ^     12.d0*g*RL2(9,2)*RL2(9,6)*RN(1,5) + 
     ^     12.d0*g*RL2(9,4)*RL2(9,6)*RN(1,5) - 
     ^     12.d0*g*RL2(9,3)*RL2(9,7)*RN(1,5) + 
     ^     12.d0*g*RL2(9,5)*RL2(9,7)*RN(1,5) + 
     ^     7.d0*g*RL2(9,2)**2*RN(1,4)*Sqrt2 + 
     ^     7.d0*g*RL2(9,3)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(9,4)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(9,5)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(9,6)**2*RN(1,4)*Sqrt2 + 
     ^     4.d0*g*RL2(9,7)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(9,8)**2*RN(1,4)*Sqrt2 + 
     ^     g*RL2(9,9)**2*RN(1,4)*Sqrt2 - 
     ^     g*RL2(9,2)**2*RN(1,6)*Sqrt2 - 
     ^     g*RL2(9,3)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(9,4)**2*RN(1,6)*Sqrt2 - 
     ^     7.d0*g*RL2(9,5)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(9,6)**2*RN(1,6)*Sqrt2 - 
     ^     4.d0*g*RL2(9,7)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(9,8)**2*RN(1,6)*Sqrt2 + 
     ^     5.d0*g*RL2(9,9)**2*RN(1,6)*Sqrt2
c
      B(9554)=-g0*RC(1,1)*RC(1,2)*s - c*g*RC(1,2)**2*s + 
     ^     g0*RC(1,1)*RC(1,3)*s + 2.d0*c*g*RC(1,2)*RC(1,3)*s - 
     ^     c*g*RC(1,3)**2*s + 2.d0*c*g*RC(1,4)**2*s + 
     ^     c*g0*RC(1,1)*RC(1,4)*Sqrt2 - g*RC(1,2)*RC(1,4)*Sqrt2 + 
     ^     g*RC(1,3)*RC(1,4)*Sqrt2 + 2.d0*g*RC(1,2)*RC(1,4)*s**2*Sqrt2 - 
     ^     2.d0*g*RC(1,3)*RC(1,4)*s**2*Sqrt2
      B(9581)=1.d0*((-g0)*RC(2,1)*RC(2,2)*s - 
     ^     c*g*RC(2,2)**2*s + 
     ^     g0*RC(2,1)*RC(2,3)*s + 
     ^     2.d0*c*g*RC(2,2)*RC(2,3)*s - 
     ^     c*g*RC(2,3)**2*s + 
     ^     2.d0*c*g*RC(2,4)**2*s + 
     ^     c*g0*RC(2,1)*RC(2,4)*Sqrt2 - 
     ^     g*RC(2,2)*RC(2,4)*Sqrt2 + 
     ^     g*RC(2,3)*RC(2,4)*Sqrt2 + 
     ^     2.d0*g*RC(2,2)*RC(2,4)*s**2*Sqrt2 - 
     ^     2.d0*g*RC(2,3)*RC(2,4)*s**2*Sqrt2)
      B(9600)=-g0*RC(3,1)*RC(3,2)*s - c*g*RC(3,2)**2*s + 
     ^     g0*RC(3,1)*RC(3,3)*s + 2.d0*c*g*RC(3,2)*RC(3,3)*s - 
     ^     c*g*RC(3,3)**2*s + 2.d0*c*g*RC(3,4)**2*s + 
     ^     c*g0*RC(3,1)*RC(3,4)*Sqrt2 - g*RC(3,2)*RC(3,4)*Sqrt2 + 
     ^     g*RC(3,3)*RC(3,4)*Sqrt2 + 2.d0*g*RC(3,2)*RC(3,4)*s**2*Sqrt2 - 
     ^     2.d0*g*RC(3,3)*RC(3,4)*s**2*Sqrt2
      B(9611)=-g0*RC(4,1)*RC(4,2)*s - c*g*RC(4,2)**2*s + 
     ^     g0*RC(4,1)*RC(4,3)*s + 2.d0*c*g*RC(4,2)*RC(4,3)*s - 
     ^     c*g*RC(4,3)**2*s + 2.d0*c*g*RC(4,4)**2*s + 
     ^     c*g0*RC(4,1)*RC(4,4)*Sqrt2 - g*RC(4,2)*RC(4,4)*Sqrt2 + 
     ^     g*RC(4,3)*RC(4,4)*Sqrt2 + 2.d0*g*RC(4,2)*RC(4,4)*s**2*Sqrt2 - 
     ^     2.d0*g*RC(4,3)*RC(4,4)*s**2*Sqrt2
c
      B(17385)=-4.d0*g0*RC(1,1)**2*RN(1,1) - 
     ^     4.d0*g*RC(1,2)**2*RN(1,3) -
     ^     2.d0*g*RC(1,4)**2*RN(1,3) - 
     ^     4.d0*g*RC(1,2)*RC(1,4)*RN(1,5) -
     ^     4.d0*g*RC(1,3)*RC(1,4)*RN(1,5) - 
     ^     2.d0*g*RC(1,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RC(1,4)**2*RN(1,4)*Sqrt2 - 
     ^     2.d0*g*RC(1,3)**2*RN(1,6)*Sqrt2 - 
     ^     g*RC(1,4)**2*RN(1,6)*Sqrt2
      B(17883)=-4.d0*g0*RC(2,1)**2*RN(1,1) - 
     ^     4.d0*g*RC(2,2)**2*RN(1,3) - 
     ^     2.d0*g*RC(2,4)**2*RN(1,3) - 
     ^     4.d0*g*RC(2,2)*RC(2,4)*RN(1,5) - 
     ^     4.d0*g*RC(2,3)*RC(2,4)*RN(1,5) - 
     ^     2.d0*g*RC(2,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RC(2,4)**2*RN(1,4)*Sqrt2 - 
     ^     2.d0*g*RC(2,3)**2*RN(1,6)*Sqrt2 - 
     ^     g*RC(2,4)**2*RN(1,6)*Sqrt2
      B(18231)=-4.d0*g0*RC(3,1)**2*RN(1,1) - 
     ^     4.d0*g*RC(3,2)**2*RN(1,3) - 
     ^     2.d0*g*RC(3,4)**2*RN(1,3) - 
     ^     4.d0*g*RC(3,2)*RC(3,4)*RN(1,5) - 
     ^     4.d0*g*RC(3,3)*RC(3,4)*RN(1,5) - 
     ^     2.d0*g*RC(3,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RC(3,4)**2*RN(1,4)*Sqrt2 - 
     ^     2.d0*g*RC(3,3)**2*RN(1,6)*Sqrt2 - 
     ^     g*RC(3,4)**2*RN(1,6)*Sqrt2
      B(18429)=-4.d0*g0*RC(4,1)**2*RN(1,1) - 
     ^     4.d0*g*RC(4,2)**2*RN(1,3) - 
     ^     2.d0*g*RC(4,4)**2*RN(1,3) - 
     ^     4.d0*g*RC(4,2)*RC(4,4)*RN(1,5) - 
     ^     4.d0*g*RC(4,3)*RC(4,4)*RN(1,5) - 
     ^     2.d0*g*RC(4,3)**2*RN(1,4)*Sqrt2 - 
     ^     g*RC(4,4)**2*RN(1,4)*Sqrt2 - 
     ^     2.d0*g*RC(4,3)**2*RN(1,6)*Sqrt2 - 
     ^     g*RC(4,4)**2*RN(1,6)*Sqrt2
c
      END

c     #############################
c     #####                   #####
c     #####  c Coupling map   #####
C     #####                   #####
C     #############################

      SUBROUTINE ccoupb2(GGG,FFF,cHBb,cZ1Bb)
      INTEGER i,j,k
      DOUBLE PRECISION cHBb(9),cZ1Bb(9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     %     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      do i=1,9
         cHBb(i)=-1.d0/(4.d0*f)
      enddo
c
      do i=1,9
         cZ1Bb(i)=-1.d0/24.d0
      enddo
c
      END

c     #############################
c     #####                   #####
c     ##### H  Coupling map   #####
C     #####                   #####
C     #############################

      SUBROUTINE hcoupb2(GGG,FFF,aHBb,B)
      INTEGER i,j,k
      DOUBLE PRECISION aHBb(9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     %     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2,B(28803)
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      aHBb(1)=B(3)
      aHBb(2)=B(1183)
      aHBb(3)=B(2355)
      aHBb(4)=B(3519)
      aHBb(5)=B(4675)
      aHBb(6)=B(5823)
      aHBb(7)=B(6963)
      aHBb(8)=B(8095)
      aHBb(9)=B(9219)
c
      END

c     #############################
c     #####                   #####
c     #####  Z1 Coupling map  #####
C     #####                   #####
C     #############################

      SUBROUTINE zcoupb2(GGG,FFF,aZ1Bb,B)
      INTEGER i,j,k
      DOUBLE PRECISION aZ1Bb(9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2,B(28803)
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      aZ1Bb(1)=B(9)
      aZ1Bb(2)=B(1189)
      aZ1Bb(3)=B(2361)
      aZ1Bb(4)=B(3525)
      aZ1Bb(5)=B(4681)
      aZ1Bb(6)=B(5829)
      aZ1Bb(7)=B(6969)
      aZ1Bb(8)=B(8101)
      aZ1Bb(9)=B(9225)
c
      END

c     #############################
c     #####                   #####
c     #####  c Coupling map   #####
C     #####                   #####
C     #############################

      SUBROUTINE ccoupt2(GGG,FFF,cHTt,cZ1Tt)
      INTEGER i,j,k
      DOUBLE PRECISION cHTt(9),cZ1Tt(9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     %     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      do i=1,9
         cHTt(i)=-1.d0/(4.d0*f)
      enddo
c
      do i=1,9
         cZ1Tt(i)=1.d0/24.d0
      enddo
c
      END

c     #############################
c     #####                   #####
c     ##### H  Coupling map   #####
C     #####                   #####
C     #############################

      SUBROUTINE hcoupt2(GGG,FFF,aHTt,B)
      INTEGER i,j,k
      DOUBLE PRECISION aHTt(9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     %     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2,B(28803)
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      aHTt(1)=B(10071)
      aHTt(2)=B(11003)
      aHTt(3)=B(11927)
      aHTt(4)=B(12843)
      aHTt(5)=B(13751)
      aHTt(6)=B(14651)
      aHTt(7)=B(15543)
      aHTt(8)=B(16427)
      aHTt(9)=B(17303)
c
      END

c     #############################
c     #####                   #####
c     #####  Z1 Coupling map  #####
C     #####                   #####
C     #############################

      SUBROUTINE zcoupt2(GGG,FFF,aZ1Tt,B)
      INTEGER i,j,k
      DOUBLE PRECISION aZ1Tt(9)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2,B(28803)
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      aZ1Tt(1)=B(10077)
      aZ1Tt(2)=B(11009)
      aZ1Tt(3)=B(11933)
      aZ1Tt(4)=B(12849)
      aZ1Tt(5)=B(13757)
      aZ1Tt(6)=B(14657)
      aZ1Tt(7)=B(15549)
      aZ1Tt(8)=B(16433)
      aZ1Tt(9)=B(17309)
c
      END
c
c     #############################
c     #####                   #####
c     #####  c Coupling map   #####
C     #####                   #####
C     #############################

      SUBROUTINE ccoupw2(GGG,FFF,cHWW,cZ1WW)
      INTEGER i,j,k
      DOUBLE PRECISION cHWW(4),cZ1WW(4)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     %     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      do i=1,4
         cHWW(i)=-f*g/2.d0
      enddo
c
      do i=1,4
         cZ1WW(i)=-1.d0/4.d0
      enddo
c
      END

c     #############################
c     #####                   #####
c     ##### H  Coupling map   #####
C     #####                   #####
C     #############################

      SUBROUTINE hcoupw2(GGG,FFF,aHWW,B)
      INTEGER i,j,k
      DOUBLE PRECISION aHWW(4)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     %     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2,B(28803)
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      aHWW(1)=B(9554)
      aHWW(2)=B(9581)
      aHWW(3)=B(9600)
      aHWW(4)=B(9611)
c
      END

c     #############################
c     #####                   #####
c     #####  Z1 Coupling map  #####
C     #####                   #####
C     #############################

      SUBROUTINE zcoupw2(GGG,FFF,aZ1WW,B)
      INTEGER i,j,k
      DOUBLE PRECISION aZ1WW(4)
      double precision GGG(6),FFF(9),g0,g,g0y,f,h,GG,
     ^     mm,DBL,DBR,DTL,DTR,YB,YT,MYB,MYT,Sqrt2,B(28803)
c     
      Sqrt2=dsqrt(2.d0)
c     
      f=GGG(1)
      g=GGG(2)
      g0=GGG(3)
      g0y=GGG(4)
      h=GGG(5)
      GG=GGG(6)
c     
      mm=FFF(1)
      DBL=FFF(2)
      DBR=FFF(3)
      DTL=FFF(4)
      DTR=FFF(5)
      YB=FFF(6)
      YT=FFF(7)
      MYB=FFF(8)
      MYT=FFF(9)
c
      aZ1WW(1)=B(17385)
      aZ1WW(2)=B(17883)
      aZ1WW(3)=B(18231)
      aZ1WW(4)=B(18429)
c
      END

c     #######################
c     #####             #####
c     #####  JACOBI     #####
C     #####             #####
C     #######################



      SUBROUTINE jacobi2(a,n,np,d,v,nrot)
      INTEGER n,np,nrot,NMAX
      DOUBLE PRECISION a(np,np),d(np),v(np,np)
      PARAMETER (NMAX=500)
C     Computes all eigenvalues and eigenvectors of a real symmetric 
c     matrix a, which is of size n by n, stored in a physical np by 
c     np array. On output, elements of a above the diagonal are 
c     destroyed. d returns the eigenvalues of a in its first n elements. 
c     v is a matrix with the same logical and physical dimensions as a, 
c     whose columns contain, on output, the normalized eigenvectors of a. 
c     nrot returns the number of Jacobi rotations that were required. 
      INTEGER i,ip,iq,j
      DOUBLE PRECISION c,g,h,s,sm,t,tau,theta,tresh,b(NMAX),z(NMAX)
      do ip=1,n
c     Initialize to the identity matrix.
         do iq=1,n
            v(ip,iq)=0.d0
         enddo
         v(ip,ip)=1.d0
      enddo
      do ip=1,n
         b(ip)=a(ip,ip)
c     Initialize b and d to the diagonal of a.
         d(ip)=b(ip)
         z(ip)=0.d0
c     This vector will accumulate terms of the form tapq
      enddo
c     as in equation (11.1.14).
      nrot=0
      do i=1,50
         sm=0.d0
         do ip=1,n-1
c     Sum off-diagonal elements.
            do iq=ip+1,n
               sm=sm+abs(a(ip,iq))
            enddo
         enddo
         if(sm.eq.0.d0)return
c     The normal return, which relies on quadratic conver-
         if(i.lt.4)then
c     gence to machine underflow.
            tresh=0.2d0*sm/n**2
c     ...on the first three sweeps.
         else
            tresh=0.d0
c     ...thereafter.
         endif
         do ip=1,n-1
            do iq=ip+1,n
               g=100.d0*abs(a(ip,iq))
c     After four sweeps, skip the rotation if the off-diagonal element is small.
               if((i.gt.4).and.(abs(d(ip))+g.eq.abs(d(ip)))
     ^              .and.(abs(d(iq))+g.eq.abs(d(iq))))then
               a(ip,iq)=0.d0
            else if(abs(a(ip,iq)).gt.tresh)then
               h=d(iq)-d(ip)
               if(abs(h)+g.eq.abs(h))then
                  t=a(ip,iq)/h
c     t = 1/(2θ)
               else
                  theta=0.5d0*h/a(ip,iq)
c     Equation (11.1.10).
                  t=1.d0/(abs(theta)+sqrt(1.d0+theta**2))
                  if(theta.lt.0.d0)t=-t
               endif
               c=1.d0/sqrt(1+t**2)
               s=t*c
               tau=s/(1.d0+c)
               h=t*a(ip,iq)
               z(ip)=z(ip)-h
               z(iq)=z(iq)+h
               d(ip)=d(ip)-h
               d(iq)=d(iq)+h
               a(ip,iq)=0.d0
               do j=1,ip-1
c     Case of rotations 1 ≤ j < p.
                  g=a(j,ip)
                  h=a(j,iq)
                  a(j,ip)=g-s*(h+g*tau)
                  a(j,iq)=h+s*(g-h*tau)
               enddo
               do j=ip+1,iq-1
c     Case of rotations p < j < q.
                  g=a(ip,j)
                  h=a(j,iq)
                  a(ip,j)=g-s*(h+g*tau)
                  a(j,iq)=h+s*(g-h*tau)
               enddo
               do j=iq+1,n
c     Case of rotations q < j ≤ n.
                  g=a(ip,j)
                  h=a(iq,j)
                  a(ip,j)=g-s*(h+g*tau)
                  a(iq,j)=h+s*(g-h*tau)
               enddo
               do j=1,n
                  g=v(j,ip)
                  h=v(j,iq)
                  v(j,ip)=g-s*(h+g*tau)
                  v(j,iq)=h+s*(g-h*tau)
               enddo
               nrot=nrot+1
            endif
         enddo
      enddo
      do ip=1,n
         b(ip)=b(ip)+z(ip)
         d(ip)=b(ip)
c     Update d with the sum of tapq ,
         z(ip)=0.d0
c     and reinitialize z.
      enddo
      enddo
c     pause ’too many iterations in jacobi’
      return
      END


c     #######################
c     #####             #####
c     #####  EIGENSRT   #####
C     #####             #####
C     #######################


c
      SUBROUTINE eigsrt2(d,v,n,np)
      INTEGER n,np
      DOUBLE PRECISION d(np),v(np,np)
c     Given the eigenvalues d and eigenvectors v as output from 
c     jacobi, this routine sorts the eigenvalues into ascending 
c     order, and rearranges the columns of v correspondingly. The 
c     method is straight insertion.
      INTEGER i,j,k
      DOUBLE PRECISION p
      do i=1,n-1
         k=i
         p=d(i)
         do j=i+1,n
            if(d(j).le.p)then
               k=j
               p=d(j)
            endif
         enddo
         if(k.ne.i)then
            d(k)=d(i)
            d(i)=p
            do j=1,n
               p=v(j,i)
               v(j,i)=v(j,k)
               v(j,k)=p
            enddo
         endif
      enddo
      return
      END
c
      SUBROUTINE transpose2(mat,n)
      DOUBLE PRECISION mat(n,n), aux(n,n)
      INTEGER i,j,n
c
      do i=1,n
         do j=1,n
            aux(i,j)=mat(j,i)
         enddo
      enddo
c
      do i=1,n
         do j=1,n
            mat(i,j)=aux(i,j)
         enddo
      enddo
c
      return
      END
c===================================
C Subroutine per il calcolo del prodotto matrice - matrice
C====================================================================
      SUBROUTINE matxmat2(A,B,n,m,r,maxdim,C)
      IMPLICIT NONE
C
C Variabili INGRESSO:
C     A       matrice n righe ed m colonne
C     B       matrice m righe ed r colonne
C     n       numero di righe di A e numero di righe di C
C     m       numero di colonne di A e numero di righe di B
C     r       numero di colonne di B e numero di colonne di C
C     maxdim  numero massimo di righe di A, B, C (come da 
C             dimensionamento)
C
C Variabili USCITA:
C     C       matrice prodotto n righe ed r colonne
C
C====================
C Parte dichiarativa
C====================
      INTEGER n, m, r, maxdim
      INTEGER i, j, k
      REAL*8 A(1:maxdim,*), B(1:maxdim,*), C(1:maxdim,*)
      REAL*8 acc
C====================
C Parte esecutiva
C====================
      do i = 1, n
        do j = 1, r
	  acc = 0.0d0
	  do k = 1, m
             acc = acc + A(i,k)*B(k,j)
	  end do
	  C(i,j) = acc
        end do
      end do
      return
      end
